/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Delegate_$type, fromEnum, runOn, markType, Point_$type, typeGetValue, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, EventArgs, delegateCombine, typeCast, fromEn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ScaleTransform } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { stringReplace, stringIsNullOrEmpty } from "igniteui-react-core";
import { TransformGroup } from "igniteui-react-core";
import { TranslateTransform } from "igniteui-react-core";
import { SuffixShiftType_$type } from "./SuffixShiftType";
import { PrefixShiftType_$type } from "./PrefixShiftType";
import { LabelShiftType_$type } from "./LabelShiftType";
import { MouseButtonEventArgs } from "igniteui-react-core";
import { KeyEventArgs } from "igniteui-react-core";
import { InputShiftType_$type } from "./InputShiftType";
import { InputGroupDisplayType_$type } from "./InputGroupDisplayType";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { ThemeResolver } from "./ThemeResolver";
import { ObservableCollection$1 } from "igniteui-react-core";
import { AnimationKeyFrameProperty } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
import { MaskParsingService } from "./MaskParsingService";
import { InputChangeEventArgs } from "./InputChangeEventArgs";
import { MaskOptions } from "./MaskOptions";
/**
 * @hidden
 */
export let InputGroupView = /*@__PURE__*/ (() => {
    class InputGroupView extends Base {
        constructor() {
            super();
            this.d = null;
            this.l = null;
            this.e = null;
            this.i = new List$1(Delegate_$type, 0);
            this.y = null;
            this.f = true;
            this.n = null;
            this.o = null;
            this.p = null;
            this.s = null;
            this.r = null;
            this.q = null;
            this.m = null;
        }
        ag() {
        }
        g() {
            return true;
        }
        get v() {
            return this.n;
        }
        get ao() {
            return null;
        }
        get h() {
            return true;
        }
        ad(a) {
            if (a == null) {
                for (let b of fromEnum(this.i)) {
                    b();
                }
                this.i.clear();
            }
            this.l = a;
            a.rootWrapper.setStyleProperty("position", "relative");
            a.rootWrapper.setStyleProperty("box-sizing", "border-box");
            a.rootWrapper.setStyleProperty("border-width", "0px");
            a.rootWrapper.setStyleProperty("border-style", "solid");
            let c = this.u;
            this.i.add(c.listen("focusin", runOn(this, this.af)));
            this.i.add(c.listen("focusout", runOn(this, this.ai)));
            let d = this.l.createElement("div");
            d.setStyleProperty("position", "absolute");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            d.setStyleProperty("border-style", "solid");
            d.setStyleProperty("box-sizing", "border-box");
            d.setStyleProperty("left", "0px");
            d.setStyleProperty("top", "0px");
            this.l.append(d);
            this.m = d;
            let e = this.l.createElement("div");
            e.addClass("ig-input-content");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("position", "relative");
            e.setStyleProperty("display", "flex");
            e.setStyleProperty("flex-direction", "row");
            e.setStyleProperty("flex-wrap", "no-wrap");
            e.setStyleProperty("flex-flow", "row nowrap");
            e.setStyleProperty("flex-grow", "1");
            e.setStyleProperty("align-items", "center");
            e.setStyleProperty("padding-top", "1.125rem");
            this.p = e;
            this.i.add(e.listen("click", runOn(this, this.z)));
            this.l.append(e);
            this.l.getPortal(e, "ChildContent", (f) => {
                let comp_ = f.componentRef;
                this.s = comp_;
                this.p.setStyleProperty("flex-direction", "row");
            }, true);
            let f = this.l.createElement("div");
            f.setStyleProperty("position", "absolute");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("background-color", "rgba(0, 0, 0, 0.54)");
            f.setStyleProperty("height", "1px");
            f.setStyleProperty("pointer-events", "none");
            f.setStyleProperty("left", "0px");
            f.setStyleProperty("bottom", "1px");
            f.setStyleProperty("overflow", "visible");
            let g = this.l.createElement("span");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "2px");
            g.setStyleProperty("display", "block");
            g.setStyleProperty("pointer-events", "none");
            NativeUI.z(g, ((() => {
                let $ret = new ScaleTransform();
                $ret.l = 0.5;
                $ret.m = 1;
                return $ret;
            })()));
            g.setStyleProperty("opacity", "0");
            this.r = g;
            f.append(this.r);
            this.q = f;
            this.l.append(f);
            this.d.l6();
        }
        get u() {
            return this.l.rootWrapper;
        }
        get t() {
            return this.m;
        }
        get w() {
            return this.q;
        }
        get x() {
            return this.r;
        }
        am(a) {
            if (this.y != a) {
                this.y = a;
                if (this.o != null) {
                    this.o.setAttribute("d", this.y);
                }
            }
        }
        al() {
            switch (this.d.g) {
                case 1:
                    this.p.setStyleProperty("padding-top", "1.125rem");
                    break;
                case 2:
                    this.p.setStyleProperty("padding-top", ".94737rem");
                    break;
                case 3:
                    this.p.setStyleProperty("padding-top", ".81818rem");
                    break;
            }
        }
        z(a) {
        }
        ah() {
            if (this.g()) {
            }
        }
        j() {
            let a = this.l.rootWrapper.getStyleProperty("height");
            return parseFloat(stringReplace(a, "px", ""));
        }
        ac() {
            this.f = true;
        }
        ae() {
            this.f = false;
            for (let a of fromEnum(this.i)) {
                a();
            }
            this.i.clear();
        }
        an(a) {
            if (a != null) {
                this.l.rootWrapper.setStyleProperty("font", a.fontString);
            }
        }
        k(a) {
            return a.view.h();
        }
        ab() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.l;
            }
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.t, 0, null, a);
        }
        c(a) {
            return new AnimationKeyFrameEffect(0, this.w, 0, null, a);
        }
        b(a) {
            return new AnimationKeyFrameEffect(0, this.r, 0, null, a);
        }
        ak(a) {
        }
        aa(a) {
            this.p.append(a);
        }
        aj(a) {
            this.p.removeChild(a);
        }
        af(a) {
            this.d.l2();
        }
        ai(a) {
            this.d.l4();
        }
    }
    InputGroupView.$t = /*@__PURE__*/ markType(InputGroupView, 'InputGroupView');
    return InputGroupView;
})();
/**
 * @hidden
 */
export let SuffixView = /*@__PURE__*/ (() => {
    class SuffixView extends Base {
        constructor() {
            super();
            this.a = null;
            this.g = null;
            this.b = null;
            this.e = new List$1(Delegate_$type, 0);
            this.c = true;
            this.h = null;
        }
        o() {
        }
        d() {
            return true;
        }
        get r() {
            return null;
        }
        m(a) {
            if (a == null) {
                for (let b of fromEnum(this.e)) {
                    b();
                }
                this.e.clear();
            }
            this.g = a;
            this.g.rootWrapper.setStyleProperty("display", "inline-block");
            let c = this.g.createElement("div");
            c.addClass("ig-suffix-content");
            this.g.append(c);
            c.setStyleProperty("cursor", "pointer");
            this.h = c;
            this.g.getPortal(c, "ChildContent", (d) => {
            }, true);
            this.a.aj();
        }
        q() {
            let a = new TransformGroup();
            a.j.add(((() => {
                let $ret = new TranslateTransform();
                $ret.k = this.a.j == 2 ? (this.f() * -0.25) : 0;
                return $ret;
            })()));
            a.j.add(((() => {
                let $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            NativeUI.z(this.g.rootWrapper, a);
            this.g.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
        }
        f() {
            let a = this.g.rootWrapper.getStyleProperty("height");
            return parseFloat(stringReplace(a, "px", ""));
        }
        p() {
            if (this.d()) {
            }
        }
        i(a) {
            this.a.ag();
        }
        j(a) {
            this.a.ah();
        }
        l() {
            this.c = true;
            this.e.add(this.g.rootWrapper.listen("mouseenter", runOn(this, this.i)));
            this.e.add(this.g.rootWrapper.listen("mouseleave", runOn(this, this.j)));
        }
        n() {
            this.c = false;
            for (let a of fromEnum(this.e)) {
                a();
            }
            this.e.clear();
        }
        k(a) {
            this.h.append(a);
        }
    }
    SuffixView.$t = /*@__PURE__*/ markType(SuffixView, 'SuffixView');
    return SuffixView;
})();
/**
 * @hidden
 */
export let PrefixView = /*@__PURE__*/ (() => {
    class PrefixView extends Base {
        constructor() {
            super();
            this.a = null;
            this.g = null;
            this.b = null;
            this.e = new List$1(Delegate_$type, 0);
            this.c = true;
            this.h = null;
        }
        o() {
        }
        d() {
            return true;
        }
        get r() {
            return null;
        }
        m(a) {
            if (a == null) {
                for (let b of fromEnum(this.e)) {
                    b();
                }
                this.e.clear();
            }
            this.g = a;
            this.g.rootWrapper.setStyleProperty("display", "inline-block");
            let c = this.g.createElement("div");
            c.addClass("ig-prefix-content");
            this.g.append(c);
            c.setStyleProperty("cursor", "pointer");
            this.h = c;
            this.g.getPortal(c, "ChildContent", (d) => {
            }, true);
            this.a.aj();
        }
        q() {
            let a = new TransformGroup();
            a.j.add(((() => {
                let $ret = new TranslateTransform();
                $ret.k = this.a.j == 2 ? (this.f() * -0.25) : 0;
                return $ret;
            })()));
            a.j.add(((() => {
                let $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            NativeUI.z(this.g.rootWrapper, a);
            this.g.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
        }
        f() {
            let a = this.g.rootWrapper.getStyleProperty("height");
            return parseFloat(stringReplace(a, "px", ""));
        }
        p() {
            if (this.d()) {
            }
        }
        i(a) {
            this.a.ag();
        }
        j(a) {
            this.a.ah();
        }
        l() {
            this.c = true;
            this.e.add(this.g.rootWrapper.listen("mouseenter", runOn(this, this.i)));
            this.e.add(this.g.rootWrapper.listen("mouseleave", runOn(this, this.j)));
        }
        n() {
            this.c = false;
            for (let a of fromEnum(this.e)) {
                a();
            }
            this.e.clear();
        }
        k(a) {
            this.h.append(a);
        }
    }
    PrefixView.$t = /*@__PURE__*/ markType(PrefixView, 'PrefixView');
    return PrefixView;
})();
/**
 * @hidden
 */
export let LabelView = /*@__PURE__*/ (() => {
    class LabelView extends Base {
        constructor() {
            super();
            this.b = null;
            this.i = null;
            this.c = null;
            this.g = new List$1(Delegate_$type, 0);
            this.m = null;
            this.d = true;
            this.j = null;
            this.k = null;
        }
        y() {
        }
        e() {
            return true;
        }
        get l() {
            return this.j;
        }
        get ag() {
            return null;
        }
        get f() {
            return true;
        }
        q() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.i;
            }
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.i.rootWrapper, 0, null, a);
        }
        t(a) {
            if (a == null) {
                for (let b of fromEnum(this.g)) {
                    b();
                }
                this.g.clear();
            }
            this.i = a;
            this.i.rootWrapper.setStyleProperty("display", "inline-block");
            this.i.rootWrapper.setStyleProperty("position", "relative");
            let c = this.i.createElement("label");
            c.setStyleProperty("position", "relative");
            c.setStyleProperty("display", "inline-block");
            c.setStyleProperty("white-space", "nowrap");
            c.setStyleProperty("text-overflow", "ellipsis");
            c.setStyleProperty("line-height", "1");
            c.setStyleProperty("overflow", "hidden");
            c.setStyleProperty("height", "1.125rem");
            c.setStyleProperty("backface-visibility", "hidden");
            NativeUI.n(this.i.rootWrapper, this.b.cq);
            c.setStyleProperty("outline-style", "none");
            c.setStyleProperty("box-shadow", "none");
            c.setStyleProperty("font-family", "'Segoe UI', Verdana");
            c.setStyleProperty("font-size", "1rem");
            this.j = c;
            this.i.append(this.j);
            this.b.b9();
        }
        ac() {
            this.b.bc = "block";
            let a = new TransformGroup();
            a.j.add(((() => {
                let $ret = new TranslateTransform();
                $ret.k = this.b.r == 0 ? (this.h() * 0.5) : 0;
                return $ret;
            })()));
            a.j.add(((() => {
                let $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            NativeUI.z(this.i.rootWrapper, a);
            this.j.setStyleProperty("height", "1.125rem");
            this.i.rootWrapper.setStyleProperty("position", "absolute");
            this.i.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
        }
        ad() {
            switch (this.b.o) {
                case 1:
                    this.i.rootWrapper.setStyleProperty("margin-top", "0px");
                    break;
                case 2:
                    this.i.rootWrapper.setStyleProperty("margin-top", "-.125rem");
                    break;
                case 3:
                    this.i.rootWrapper.setStyleProperty("margin-top", "-.25rem");
                    break;
            }
        }
        ab() {
            this.j.setText(this.b.text != null ? this.b.text : "");
        }
        ae(a) {
            if (this.m != a) {
                this.m = a;
                if (this.k != null) {
                    this.k.setAttribute("d", this.m);
                }
            }
        }
        v() {
            if (this.i != null) {
                this.i.rootWrapper.setStyleProperty("display", this.b.bc);
                this.j.setStyleProperty("display", this.b.bc);
                let ext_ = this.i.getExternal(this.b, null, null);
                if (ext_ && ext_._onDisplayChanged) {
                    ext_._onDisplayChanged();
                }
                ;
            }
        }
        r() {
            if (this.i != null) {
                this.i.rootWrapper.setStyleProperty("align-items", this.b.a6);
                this.j.setStyleProperty("align-items", this.b.a6);
                let ext_ = this.i.getExternal(this.b, null, null);
                if (ext_ && ext_._onAlignItemsChanged) {
                    ext_._onAlignItemsChanged();
                }
                ;
            }
        }
        w() {
            if (this.i != null) {
                this.i.rootWrapper.setStyleProperty("flex-direction", this.b.be);
                this.j.setStyleProperty("flex-direction", this.b.be);
                let ext_ = this.i.getExternal(this.b, null, null);
                if (ext_ && ext_._onFlexDirectionChanged) {
                    ext_._onFlexDirectionChanged();
                }
                ;
            }
        }
        x() {
            if (this.i != null) {
                this.i.rootWrapper.setStyleProperty("flex-grow", this.b.bg);
                this.j.setStyleProperty("flex-grow", this.b.bg);
                let ext_ = this.i.getExternal(this.b, null, null);
                if (ext_ && ext_._onFlexGrowChanged) {
                    ext_._onFlexGrowChanged();
                }
                ;
            }
        }
        n(a) {
        }
        z() {
            if (this.e()) {
            }
        }
        h() {
            let a = this.i.rootWrapper.getStyleProperty("height");
            return parseFloat(stringReplace(a, "px", ""));
        }
        o(a) {
            this.b.b6();
        }
        p(a) {
            this.b.b7();
        }
        s() {
            this.d = true;
            this.g.add(this.i.rootWrapper.listen("mouseenter", runOn(this, this.o)));
            this.g.add(this.i.rootWrapper.listen("mouseleave", runOn(this, this.p)));
        }
        u() {
            this.d = false;
            for (let a of fromEnum(this.g)) {
                a();
            }
            this.g.clear();
        }
        af(a) {
            if (a != null) {
                this.j.setStyleProperty("font", a.fontString);
            }
        }
        aa(a) {
            NativeUI.n(this.j, a);
        }
    }
    LabelView.$t = /*@__PURE__*/ markType(LabelView, 'LabelView');
    return LabelView;
})();
/**
 * @hidden
 */
export let InputView = /*@__PURE__*/ (() => {
    class InputView extends Base {
        constructor() {
            super();
            this.a = null;
            this.i = null;
            this.b = null;
            this.g = new List$1(Delegate_$type, 0);
            this.d = false;
            this.o = null;
            this.c = true;
            this.j = null;
            this.k = null;
        }
        al() {
        }
        e() {
            return true;
        }
        get n() {
            return this.j;
        }
        get az() {
            return null;
        }
        get f() {
            return true;
        }
        ai(a) {
            if (a == null) {
                for (let b of fromEnum(this.g)) {
                    b();
                }
                this.g.clear();
            }
            this.i = a;
            this.i.rootWrapper.setStyleProperty("display", "inline-block");
            let c = this.i.createElement("input");
            c.setAttribute("type", this.a.bs);
            c.setStyleProperty("position", "relative");
            c.setStyleProperty("box-sizing", "border-box");
            c.setStyleProperty("display", "inline-block");
            c.setStyleProperty("border", "none");
            c.setStyleProperty("height", "2rem");
            c.setStyleProperty("line-height", "0");
            c.setStyleProperty("width", "100%");
            c.setStyleProperty("min-width", "0");
            c.setStyleProperty("overflow", "visible");
            c.setStyleProperty("background", "transparent");
            c.setStyleProperty("background-position-x", "initial");
            c.setStyleProperty("background-position-y", "initial");
            c.setStyleProperty("background-size", "initial");
            c.setStyleProperty("background-repeat-x", "initial");
            c.setStyleProperty("background-repeat-y", "initial");
            c.setStyleProperty("background-attachment", "initial");
            c.setStyleProperty("background-origin", "initial");
            c.setStyleProperty("background-color", "transparent");
            NativeUI.n(c, this.a.db);
            c.setStyleProperty("outline-style", "none");
            c.setStyleProperty("box-shadow", "none");
            c.setStyleProperty("border-top", "0.1875rem solid transparent");
            c.setStyleProperty("padding-bottom", "0.1875rem");
            c.setStyleProperty("font-family", "'Segoe UI', Verdana");
            c.setStyleProperty("font-size", "1rem");
            this.g.add(c.listen("change", runOn(this, this.u)));
            this.g.add(c.listen("input", runOn(this, this.v)));
            this.g.add(c.listen("focus", runOn(this, this.aa)));
            this.g.add(c.listen("blur", runOn(this, this.t)));
            this.g.add(c.listen("mouseenter", runOn(this, this.r)));
            this.g.add(c.listen("mouseleave", runOn(this, this.s)));
            this.g.add(c.listen("keydown", runOn(this, this.ab)));
            this.g.add(c.listen("keyup", runOn(this, this.ad)));
            this.g.add(c.listen("keypress", runOn(this, this.ac)));
            this.g.add(c.listen("paste", runOn(this, this.ag)));
            this.g.add(c.listen("dragenter", runOn(this, this.y)));
            this.g.add(c.listen("dragleave", runOn(this, this.z)));
            this.g.add(c.listen("compositionstart", runOn(this, this.x)));
            this.g.add(c.listen("compositionend", runOn(this, this.w)));
            this.g.add(c.listen("mousedown", runOn(this, this.ae)));
            this.g.add(c.listen("mouseup", runOn(this, this.af)));
            this.j = c;
            this.i.append(this.j);
            this.a.cx();
        }
        x(a) {
            this.d = true;
            this.a.cg();
        }
        w(a) {
            this.d = false;
            this.a.cf();
        }
        ap() {
            this.j.setAttribute("type", this.a.bs);
            if (this.a.bs == "date") {
                this.j.setStyleProperty("line-height", "normal");
            }
            else {
                this.j.setStyleProperty("line-height", "0");
            }
        }
        an() {
            this.j.setAttribute("placeholder", this.a.by);
        }
        av() {
            switch (this.a.k) {
                case 1:
                    this.j.setStyleProperty("height", "2rem");
                    this.j.setStyleProperty("font-size", "1rem");
                    break;
                case 2:
                    this.j.setStyleProperty("height", "1.68421rem");
                    this.j.setStyleProperty("font-size", "1rem");
                    break;
                case 3:
                    this.j.setStyleProperty("height", "1.45455rem");
                    this.j.setStyleProperty("font-size", ".95455rem");
                    break;
            }
        }
        au() {
            let a = new TransformGroup();
            a.j.add(((() => {
                let $ret = new TranslateTransform();
                $ret.k = this.a.p == 2 ? (this.h() * -0.25) : 0;
                return $ret;
            })()));
            a.j.add(((() => {
                let $ret = new ScaleTransform();
                $ret.l = 1;
                $ret.m = 1;
                return $ret;
            })()));
            NativeUI.z(this.i.rootWrapper, a);
            this.i.rootWrapper.setStyleProperty("transform-origin", "0px 0px");
        }
        h() {
            let a = this.i.rootWrapper.getStyleProperty("height");
            let b = parseFloat(stringReplace(a, "px", ""));
            return b;
        }
        aq(a) {
            this.j.setProperty("value", a);
        }
        t(a) {
            this.a.cc();
        }
        aa(a) {
            this.a.ck();
        }
        ae(a) {
            let b = this.ay(a);
            this.a.cp(b);
            if (b.handled) {
                a.preventDefault();
            }
        }
        af(a) {
            let b = this.ay(a);
            this.a.cs(b);
            if (b.handled) {
                a.preventDefault();
            }
        }
        ay(a) {
            let b = new MouseButtonEventArgs();
            b.position = { $type: Point_$type, x: a.offsetX, y: a.offsetY };
            return b;
        }
        u(a) {
            this.a.cd();
        }
        v(a) {
            this.a.ce();
        }
        ab(a) {
            let b = new KeyEventArgs(0, a);
            this.a.cm(b);
        }
        ad(a) {
            let b = new KeyEventArgs(0, a);
            this.a.co(b);
        }
        ac(a) {
            let b = new KeyEventArgs(0, a);
            this.a.cn(b);
        }
        ag(a) {
            this.a.ct();
        }
        y(a) {
            this.a.ci();
        }
        z(a) {
            this.a.cj();
        }
        aw(a) {
            if (this.o != a) {
                this.o = a;
                if (this.k != null) {
                    this.k.setAttribute("d", this.o);
                }
            }
        }
        p() {
            return this.j.getProperty("value");
        }
        q(a) {
        }
        m() {
            let a = this.j.getProperty("selectionStart");
            return typeGetValue(a);
        }
        l() {
            let a = this.j.getProperty("selectionEnd");
            return typeGetValue(a);
        }
        at(a) {
            this.j.setProperty("selectionStart", a);
        }
        ar(a) {
            this.j.setProperty("selectionEnd", a);
        }
        am() {
            if (this.e()) {
            }
        }
        r(a) {
            this.a.cq();
        }
        s(a) {
            this.a.cr();
        }
        ah() {
            this.c = true;
            this.g.add(this.j.listen("change", runOn(this, this.u)));
            this.g.add(this.j.listen("input", runOn(this, this.v)));
            this.g.add(this.j.listen("focus", runOn(this, this.aa)));
            this.g.add(this.j.listen("blur", runOn(this, this.t)));
            this.g.add(this.j.listen("mouseenter", runOn(this, this.r)));
            this.g.add(this.j.listen("mouseleave", runOn(this, this.s)));
            this.g.add(this.j.listen("keydown", runOn(this, this.ab)));
            this.g.add(this.j.listen("paste", runOn(this, this.ag)));
            this.g.add(this.j.listen("dragenter", runOn(this, this.y)));
            this.g.add(this.j.listen("dragleave", runOn(this, this.z)));
            this.g.add(this.j.listen("compositionstart", runOn(this, this.x)));
            this.g.add(this.j.listen("compositionend", runOn(this, this.w)));
            this.g.add(this.j.listen("mousedown", runOn(this, this.ae)));
            this.g.add(this.j.listen("mouseup", runOn(this, this.af)));
        }
        aj() {
            this.c = false;
            for (let a of fromEnum(this.g)) {
                a();
            }
            this.g.clear();
        }
        ax(a) {
            if (a != null) {
                this.j.setStyleProperty("font", a.fontString);
            }
        }
        ak() {
            if (this.j != null) {
                this.j.focus(false);
            }
        }
        ao() {
            if (this.j != null) {
                let nativeInput_ = this.j;
                nativeInput_.getNativeElement().select();
            }
        }
        as(a, b) {
            if (this.j != null) {
                let c = this.j.getNativeElement();
                c.setSelectionRange(a, b);
            }
        }
    }
    InputView.$t = /*@__PURE__*/ markType(InputView, 'InputView');
    return InputView;
})();
/**
 * @hidden
 */
export let InputGroupItem = /*@__PURE__*/ (() => {
    class InputGroupItem extends Base {
        constructor() {
            super(...arguments);
            this.c = null;
            this.a = null;
            this.propertyChanged = null;
        }
        get e() {
            return this.c;
        }
        set e(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.g("Name", b, a);
            }
        }
        get b() {
            return this.a;
        }
        set b(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.g("InputGroup", b, a);
            }
        }
        g(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.h(a, b, c);
        }
        h(a, b, c) {
        }
    }
    InputGroupItem.$t = /*@__PURE__*/ markType(InputGroupItem, 'InputGroupItem', Base.$, [INotifyPropertyChanged_$type]);
    return InputGroupItem;
})();
/**
 * @hidden
 */
export let Suffix = /*@__PURE__*/ (() => {
    class Suffix extends InputGroupItem {
        constructor() {
            super();
            this._view = null;
            this.i = 0;
            this.t = "ig-suffix-" + Suffix.r++;
            this.s = null;
            this.m = false;
            this.l = false;
            this.n = false;
            let a = new SuffixView();
            a.a = this;
            this.view = a;
            this.view.o();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        get j() {
            return this.i;
        }
        set j(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.g("ShiftType", enumGetBox(SuffixShiftType_$type, b), enumGetBox(SuffixShiftType_$type, a));
            }
        }
        h(a, b, c) {
            super.h(a, b, c);
            switch (a) {
                case "InputGroup":
                    this.af();
                    break;
                case "ShiftType":
                    this.ai();
                    break;
            }
        }
        ai() {
            this.view.q();
        }
        af() {
            this.view.q();
        }
        am() {
        }
        al() {
        }
        ag() {
            this.p = true;
        }
        ah() {
            this.p = false;
        }
        get w() {
            return this.t;
        }
        set w(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.g("Id", b, a);
            }
        }
        get u() {
            return this.s;
        }
        set u(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.g("AriaLabel", b, a);
            }
        }
        get p() {
            return this.m;
        }
        set p(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.g("IsHover", b, a);
            }
        }
        get disabled() {
            return this.l;
        }
        set disabled(a) {
            let b = this.l;
            this.l = a;
            if (b != this.l) {
                this.g("IsDisabled", b, a);
            }
        }
        aj() {
        }
        onDetachedFromUI() {
            this.view.n();
        }
        onAttachedToUI() {
            this.view.l();
        }
        q() {
            return this.view.d();
        }
        appendContentChild(a) {
            this.view.k(a);
        }
        provideContainer(a) {
            this.view.m(a);
        }
    }
    Suffix.$t = /*@__PURE__*/ markType(Suffix, 'Suffix', InputGroupItem.$);
    Suffix.r = 0;
    return Suffix;
})();
/**
 * @hidden
 */
export let Prefix = /*@__PURE__*/ (() => {
    class Prefix extends InputGroupItem {
        constructor() {
            super();
            this._view = null;
            this.i = 0;
            this.t = "ig-prefix-" + Prefix.r++;
            this.s = null;
            this.m = false;
            this.l = false;
            this.n = false;
            let a = new PrefixView();
            a.a = this;
            this.view = a;
            this.view.o();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        get j() {
            return this.i;
        }
        set j(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.g("ShiftType", enumGetBox(PrefixShiftType_$type, b), enumGetBox(PrefixShiftType_$type, a));
            }
        }
        h(a, b, c) {
            super.h(a, b, c);
            switch (a) {
                case "InputGroup":
                    this.af();
                    break;
                case "ShiftType":
                    this.ai();
                    break;
            }
        }
        ai() {
            this.view.q();
        }
        af() {
            this.view.q();
        }
        am() {
        }
        al() {
        }
        ag() {
            this.p = true;
        }
        ah() {
            this.p = false;
        }
        get w() {
            return this.t;
        }
        set w(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.g("Id", b, a);
            }
        }
        get u() {
            return this.s;
        }
        set u(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.g("AriaLabel", b, a);
            }
        }
        get p() {
            return this.m;
        }
        set p(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.g("IsHover", b, a);
            }
        }
        get disabled() {
            return this.l;
        }
        set disabled(a) {
            let b = this.l;
            this.l = a;
            if (b != this.l) {
                this.g("IsDisabled", b, a);
            }
        }
        aj() {
        }
        onDetachedFromUI() {
            this.view.n();
        }
        onAttachedToUI() {
            this.view.l();
        }
        q() {
            return this.view.d();
        }
        appendContentChild(a) {
            this.view.k(a);
        }
        provideContainer(a) {
            this.view.m(a);
        }
    }
    Prefix.$t = /*@__PURE__*/ markType(Prefix, 'Prefix', InputGroupItem.$);
    Prefix.r = 0;
    return Prefix;
})();
/**
 * @hidden
 */
export let InputGroup = /*@__PURE__*/ (() => {
    class InputGroup extends Base {
        constructor() {
            super();
            this.i = 0;
            this.f = 1;
            this.e = 1;
            this.b = 0;
            this._view = null;
            this.p = null;
            this.n = null;
            this.lostFocus = null;
            this.gotFocus = null;
            this.db = ThemeResolver.b(InputGroup.c, InputGroup.fq, InputGroup.dx);
            this.e1 = ThemeResolver.b(InputGroup.c, InputGroup.f1, InputGroup.d8);
            this.mx = ThemeResolver.d(InputGroup.c, InputGroup.m6, InputGroup.m0);
            this.td = ThemeResolver.f(InputGroup.c, InputGroup.tm, InputGroup.tg);
            this.o6 = ThemeResolver.e(InputGroup.c, InputGroup.q4, InputGroup.po);
            this.qr = ThemeResolver.e(InputGroup.c, InputGroup.rl, InputGroup.p5);
            this.qs = ThemeResolver.e(InputGroup.c, InputGroup.rm, InputGroup.p6);
            this.g7 = ThemeResolver.b(InputGroup.c, InputGroup.gt, InputGroup.e0);
            this.g6 = ThemeResolver.b(InputGroup.c, InputGroup.gs, InputGroup.ez);
            this.e5 = ThemeResolver.b(InputGroup.c, InputGroup.f5, InputGroup.ec);
            this.sf = ThemeResolver.e(InputGroup.c, InputGroup.r5, InputGroup.qp);
            this.sg = ThemeResolver.e(InputGroup.c, InputGroup.r6, InputGroup.qq);
            this.qu = ThemeResolver.e(InputGroup.c, InputGroup.ro, InputGroup.p8);
            this.qt = ThemeResolver.e(InputGroup.c, InputGroup.rn, InputGroup.p7);
            this.g4 = ThemeResolver.b(InputGroup.c, InputGroup.gq, InputGroup.ex);
            this.e4 = ThemeResolver.b(InputGroup.c, InputGroup.f4, InputGroup.eb);
            this.e2 = ThemeResolver.b(InputGroup.c, InputGroup.f2, InputGroup.d9);
            this.e3 = ThemeResolver.b(InputGroup.c, InputGroup.f3, InputGroup.ea);
            this.g5 = ThemeResolver.b(InputGroup.c, InputGroup.gr, InputGroup.ey);
            this.o5 = ThemeResolver.e(InputGroup.c, InputGroup.q3, InputGroup.pn);
            this.e6 = ThemeResolver.b(InputGroup.c, InputGroup.f6, InputGroup.ed);
            this.e7 = ThemeResolver.b(InputGroup.c, InputGroup.f7, InputGroup.ee);
            this.m3 = ThemeResolver.d(InputGroup.c, InputGroup.m7, InputGroup.m1);
            this.tj = ThemeResolver.f(InputGroup.c, InputGroup.tn, InputGroup.th);
            this.qw = ThemeResolver.e(InputGroup.c, InputGroup.rq, InputGroup.qa);
            this.qx = ThemeResolver.e(InputGroup.c, InputGroup.rr, InputGroup.qb);
            this.qy = ThemeResolver.e(InputGroup.c, InputGroup.rs, InputGroup.qc);
            this.ff = ThemeResolver.b(InputGroup.c, InputGroup.gf, InputGroup.em);
            this.fe = ThemeResolver.b(InputGroup.c, InputGroup.ge, InputGroup.el);
            this.fb = ThemeResolver.b(InputGroup.c, InputGroup.gb, InputGroup.ei);
            this.q1 = ThemeResolver.e(InputGroup.c, InputGroup.rv, InputGroup.qf);
            this.q2 = ThemeResolver.e(InputGroup.c, InputGroup.rw, InputGroup.qg);
            this.q0 = ThemeResolver.e(InputGroup.c, InputGroup.ru, InputGroup.qe);
            this.qz = ThemeResolver.e(InputGroup.c, InputGroup.rt, InputGroup.qd);
            this.fc = ThemeResolver.b(InputGroup.c, InputGroup.gc, InputGroup.ej);
            this.fa = ThemeResolver.b(InputGroup.c, InputGroup.ga, InputGroup.eh);
            this.e8 = ThemeResolver.b(InputGroup.c, InputGroup.f8, InputGroup.ef);
            this.e9 = ThemeResolver.b(InputGroup.c, InputGroup.f9, InputGroup.eg);
            this.fd = ThemeResolver.b(InputGroup.c, InputGroup.gd, InputGroup.ek);
            this.qv = ThemeResolver.e(InputGroup.c, InputGroup.rp, InputGroup.p9);
            this.dc = ThemeResolver.b(InputGroup.c, InputGroup.fr, InputGroup.dy);
            this.dd = ThemeResolver.b(InputGroup.c, InputGroup.fs, InputGroup.dz);
            this.mw = ThemeResolver.d(InputGroup.c, InputGroup.m5, InputGroup.mz);
            this.tc = ThemeResolver.f(InputGroup.c, InputGroup.tl, InputGroup.tf);
            this.pg = ThemeResolver.e(InputGroup.c, InputGroup.re, InputGroup.py);
            this.ph = ThemeResolver.e(InputGroup.c, InputGroup.rf, InputGroup.pz);
            this.pi = ThemeResolver.e(InputGroup.c, InputGroup.rg, InputGroup.p0);
            this.dl = ThemeResolver.b(InputGroup.c, InputGroup.f0, InputGroup.d7);
            this.dk = ThemeResolver.b(InputGroup.c, InputGroup.fz, InputGroup.d6);
            this.dh = ThemeResolver.b(InputGroup.c, InputGroup.fw, InputGroup.d3);
            this.pl = ThemeResolver.e(InputGroup.c, InputGroup.rj, InputGroup.p3);
            this.pm = ThemeResolver.e(InputGroup.c, InputGroup.rk, InputGroup.p4);
            this.pk = ThemeResolver.e(InputGroup.c, InputGroup.ri, InputGroup.p2);
            this.pj = ThemeResolver.e(InputGroup.c, InputGroup.rh, InputGroup.p1);
            this.di = ThemeResolver.b(InputGroup.c, InputGroup.fx, InputGroup.d4);
            this.dg = ThemeResolver.b(InputGroup.c, InputGroup.fv, InputGroup.d2);
            this.de = ThemeResolver.b(InputGroup.c, InputGroup.ft, InputGroup.d0);
            this.df = ThemeResolver.b(InputGroup.c, InputGroup.fu, InputGroup.d1);
            this.dj = ThemeResolver.b(InputGroup.c, InputGroup.fy, InputGroup.d5);
            this.pf = ThemeResolver.e(InputGroup.c, InputGroup.rd, InputGroup.px);
            this.c1 = ThemeResolver.b(InputGroup.c, InputGroup.fg, InputGroup.dm);
            this.c2 = ThemeResolver.b(InputGroup.c, InputGroup.fh, InputGroup.dn);
            this.mv = ThemeResolver.d(InputGroup.c, InputGroup.m4, InputGroup.my);
            this.tb = ThemeResolver.f(InputGroup.c, InputGroup.tk, InputGroup.te);
            this.o8 = ThemeResolver.e(InputGroup.c, InputGroup.q6, InputGroup.pq);
            this.o9 = ThemeResolver.e(InputGroup.c, InputGroup.q7, InputGroup.pr);
            this.pa = ThemeResolver.e(InputGroup.c, InputGroup.q8, InputGroup.ps);
            this.da = ThemeResolver.b(InputGroup.c, InputGroup.fp, InputGroup.dw);
            this.c9 = ThemeResolver.b(InputGroup.c, InputGroup.fo, InputGroup.dv);
            this.c6 = ThemeResolver.b(InputGroup.c, InputGroup.fl, InputGroup.ds);
            this.pd = ThemeResolver.e(InputGroup.c, InputGroup.rb, InputGroup.pv);
            this.pe = ThemeResolver.e(InputGroup.c, InputGroup.rc, InputGroup.pw);
            this.pc = ThemeResolver.e(InputGroup.c, InputGroup.ra, InputGroup.pu);
            this.pb = ThemeResolver.e(InputGroup.c, InputGroup.q9, InputGroup.pt);
            this.c7 = ThemeResolver.b(InputGroup.c, InputGroup.fm, InputGroup.dt);
            this.c5 = ThemeResolver.b(InputGroup.c, InputGroup.fk, InputGroup.dr);
            this.c3 = ThemeResolver.b(InputGroup.c, InputGroup.fi, InputGroup.dp);
            this.c4 = ThemeResolver.b(InputGroup.c, InputGroup.fj, InputGroup.dq);
            this.c8 = ThemeResolver.b(InputGroup.c, InputGroup.fn, InputGroup.du);
            this.o7 = ThemeResolver.e(InputGroup.c, InputGroup.q5, InputGroup.pp);
            this.gu = ThemeResolver.b(InputGroup.c, InputGroup.gg, InputGroup.en);
            this.gv = ThemeResolver.b(InputGroup.c, InputGroup.gh, InputGroup.eo);
            this.m9 = ThemeResolver.d(InputGroup.c, InputGroup.m8, InputGroup.m2);
            this.tp = ThemeResolver.f(InputGroup.c, InputGroup.to, InputGroup.ti);
            this.r8 = ThemeResolver.e(InputGroup.c, InputGroup.ry, InputGroup.qi);
            this.r9 = ThemeResolver.e(InputGroup.c, InputGroup.rz, InputGroup.qj);
            this.sa = ThemeResolver.e(InputGroup.c, InputGroup.r0, InputGroup.qk);
            this.g3 = ThemeResolver.b(InputGroup.c, InputGroup.gp, InputGroup.ew);
            this.g2 = ThemeResolver.b(InputGroup.c, InputGroup.go, InputGroup.ev);
            this.gz = ThemeResolver.b(InputGroup.c, InputGroup.gl, InputGroup.es);
            this.sd = ThemeResolver.e(InputGroup.c, InputGroup.r3, InputGroup.qn);
            this.se = ThemeResolver.e(InputGroup.c, InputGroup.r4, InputGroup.qo);
            this.sc = ThemeResolver.e(InputGroup.c, InputGroup.r2, InputGroup.qm);
            this.sb = ThemeResolver.e(InputGroup.c, InputGroup.r1, InputGroup.ql);
            this.g0 = ThemeResolver.b(InputGroup.c, InputGroup.gm, InputGroup.et);
            this.gy = ThemeResolver.b(InputGroup.c, InputGroup.gk, InputGroup.er);
            this.gw = ThemeResolver.b(InputGroup.c, InputGroup.gi, InputGroup.ep);
            this.gx = ThemeResolver.b(InputGroup.c, InputGroup.gj, InputGroup.eq);
            this.g1 = ThemeResolver.b(InputGroup.c, InputGroup.gn, InputGroup.eu);
            this.r7 = ThemeResolver.e(InputGroup.c, InputGroup.rx, InputGroup.qh);
            this.nd = ThemeResolver.e(InputGroup.c, InputGroup.q4, InputGroup.po);
            this.ne = ThemeResolver.e(InputGroup.c, InputGroup.rl, InputGroup.p5);
            this.ai = ThemeResolver.b(InputGroup.c, InputGroup.fq, InputGroup.dx);
            this.aj = ThemeResolver.b(InputGroup.c, InputGroup.f1, InputGroup.d8);
            this.mk = ThemeResolver.d(InputGroup.c, InputGroup.m6, InputGroup.m0);
            this.s0 = ThemeResolver.f(InputGroup.c, InputGroup.tm, InputGroup.tg);
            this.ar = ThemeResolver.b(InputGroup.c, InputGroup.gt, InputGroup.e0);
            this.aq = ThemeResolver.b(InputGroup.c, InputGroup.gs, InputGroup.ez);
            this.an = ThemeResolver.b(InputGroup.c, InputGroup.f5, InputGroup.ec);
            this.nh = ThemeResolver.e(InputGroup.c, InputGroup.r5, InputGroup.qp);
            this.ni = ThemeResolver.e(InputGroup.c, InputGroup.r6, InputGroup.qq);
            this.ng = ThemeResolver.e(InputGroup.c, InputGroup.ro, InputGroup.p8);
            this.nf = ThemeResolver.e(InputGroup.c, InputGroup.rn, InputGroup.p7);
            this.ao = ThemeResolver.b(InputGroup.c, InputGroup.gq, InputGroup.ex);
            this.am = ThemeResolver.b(InputGroup.c, InputGroup.f4, InputGroup.eb);
            this.ak = ThemeResolver.b(InputGroup.c, InputGroup.f2, InputGroup.d9);
            this.al = ThemeResolver.b(InputGroup.c, InputGroup.f3, InputGroup.ea);
            this.ap = ThemeResolver.b(InputGroup.c, InputGroup.gr, InputGroup.ey);
            this.nc = ThemeResolver.e(InputGroup.c, InputGroup.q3, InputGroup.pn);
            this.a2 = NaN;
            this.bd = NaN;
            this.nk = null;
            this.mn = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.s3 = new Thickness(1, NaN, NaN, NaN, NaN);
            this.b5 = NaN;
            this.b4 = NaN;
            this.bh = NaN;
            this.og = null;
            this.oh = null;
            this.n1 = null;
            this.n0 = null;
            this.b2 = NaN;
            this.bg = NaN;
            this.be = NaN;
            this.bf = NaN;
            this.b3 = NaN;
            this.nj = null;
            this.bi = NaN;
            this.bj = NaN;
            this.n4 = null;
            this.n3 = null;
            this.mo = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.s4 = new Thickness(1, NaN, NaN, NaN, NaN);
            this.br = NaN;
            this.bq = NaN;
            this.bn = NaN;
            this.n7 = null;
            this.n8 = null;
            this.n6 = null;
            this.n5 = null;
            this.bo = NaN;
            this.bm = NaN;
            this.bk = NaN;
            this.bl = NaN;
            this.bp = NaN;
            this.n2 = null;
            this.a3 = NaN;
            this.a4 = NaN;
            this.nu = null;
            this.nt = null;
            this.mm = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.s2 = new Thickness(1, NaN, NaN, NaN, NaN);
            this.bc = NaN;
            this.bb = NaN;
            this.a8 = NaN;
            this.nx = null;
            this.ny = null;
            this.nw = null;
            this.nv = null;
            this.a9 = NaN;
            this.a7 = NaN;
            this.a5 = NaN;
            this.a6 = NaN;
            this.ba = NaN;
            this.ns = null;
            this.as = NaN;
            this.at = NaN;
            this.nn = null;
            this.nm = null;
            this.ml = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.s1 = new Thickness(1, NaN, NaN, NaN, NaN);
            this.a1 = NaN;
            this.a0 = NaN;
            this.ax = NaN;
            this.nq = null;
            this.nr = null;
            this.np = null;
            this.no = null;
            this.ay = NaN;
            this.aw = NaN;
            this.au = NaN;
            this.av = NaN;
            this.az = NaN;
            this.nl = null;
            this.bs = NaN;
            this.bt = NaN;
            this.ob = null;
            this.oa = null;
            this.mp = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.s5 = new Thickness(1, NaN, NaN, NaN, NaN);
            this.b1 = NaN;
            this.b0 = NaN;
            this.bx = NaN;
            this.oe = null;
            this.of = null;
            this.od = null;
            this.oc = null;
            this.by = NaN;
            this.bw = NaN;
            this.bu = NaN;
            this.bv = NaN;
            this.bz = NaN;
            this.n9 = null;
            this.w = false;
            this.s = false;
            this.y = false;
            this.u = false;
            this.x = false;
            this.t = false;
            this.q = false;
            this.nz = null;
            this.h4 = "ig-inputgroup-" + InputGroup.h3++;
            this.v = false;
            this.propertyChanged = null;
            this.k = new InputGroupInputCollection();
            this.o = null;
            this.aa = false;
            this.r = false;
            this.z = false;
            let a = new InputGroupView();
            a.d = this;
            this.view = a;
            this.view.ag();
            let b = this.k;
            b.collectionChanged = delegateCombine(b.collectionChanged, runOn(this, this.lp));
            let c = this.k;
            c.collectionResetting = delegateCombine(c.collectionResetting, runOn(this, this.lq));
        }
        lq(a, b) {
            this.md();
        }
        appendContentChild(a) {
            this.view.aa(a);
        }
        ma(a) {
            this.view.aj(a);
        }
        get j() {
            return this.i;
        }
        set j(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.l5("DisplayType", enumGetBox(InputGroupDisplayType_$type, b), enumGetBox(InputGroupDisplayType_$type, a));
            }
        }
        get h() {
            return this.f;
        }
        set h(a) {
            let b = this.f;
            this.f = a;
            if (b != this.f) {
                this.l5("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get g() {
            return this.e;
        }
        set g(a) {
            let b = this.e;
            this.e = a;
            if (b != this.e) {
                this.l5("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        lv(a) {
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(Label.$, this.inputs._inner[b]) !== null) {
                    a(this.inputs._inner[b]);
                }
            }
        }
        lw(a) {
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(Prefix.$, this.inputs._inner[b]) !== null) {
                    a(this.inputs._inner[b]);
                }
            }
        }
        lu(a) {
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(Input.$, this.inputs._inner[b]) !== null) {
                    a(this.inputs._inner[b]);
                }
            }
        }
        lx(a) {
            for (let b = 0; b < this.inputs.count; b++) {
                if (typeCast(Suffix.$, this.inputs._inner[b]) !== null) {
                    a(this.inputs._inner[b]);
                }
            }
        }
        lp(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    let d = c;
                    if (d != null) {
                        d.b = null;
                    }
                }
            }
            if (b.newItems != null) {
                for (let e of fromEn(b.newItems)) {
                    let f = e;
                    if (f != null) {
                        f.b = this;
                    }
                }
            }
            this.mg();
            this.mf();
            this.mh();
            this.mi();
            this.md();
        }
        get d() {
            return this.b;
        }
        set d(a) {
            let b = this.b;
            this.b = a;
            if (b != this.b) {
                this.l5("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        l5(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.l8(a, b, c);
        }
        l8(a, b, c) {
            switch (a) {
                case "BaseTheme":
                    this.mc(this.d);
                    this.me();
                    this.lv((d) => d.l = this.d == 0 ? 2 : this.d);
                    break;
                case "ActualBorderColor":
                case "ActualBackgroundColor":
                case "ActualBorderWidth":
                case "ActualFocusBorderColor":
                case "ActualFocusBorderWidth":
                case "ActualCornerRadius":
                case "ActualContentPadding":
                case "ActualUnderlineOpacity":
                case "ActualUnderlineRippleOpacity":
                case "ActualUnderlineRippleWidth":
                case "ActualUnderlineRippleColor":
                case "ActualUnderlineColor":
                case "ActualHoverUnderlineColor":
                case "ActualUnderlineWidth":
                case "ActualHoverUnderlineWidth":
                case "ActualHoverUnderlineOpacity":
                case "ActualFocusUnderlineColor":
                case "ActualFocusUnderlineOpacity":
                case "ActualFocusUnderlineRippleOpacity":
                case "IsHovered":
                    this.z = true;
                    this.aa = true;
                    this.r = true;
                    this.md();
                    break;
                case "BorderColor":
                case "BackgroundColor":
                case "BorderWidth":
                case "FocusBorderColor":
                case "FocusBorderWidth":
                case "CornerRadius":
                case "ContentPadding":
                case "UnderlineOpacity":
                case "UnderlineRippleOpacity":
                case "UnderlineRippleWidth":
                case "UnderlineRippleColor":
                case "UnderlineColor":
                case "HoverUnderlineColor":
                case "UnderlineWidth":
                case "HoverUnderlineWidth":
                case "HoverUnderlineOpacity":
                case "FocusUnderlineColor":
                case "FocusUnderlineOpacity":
                case "FocusUnderlineRippleOpacity":
                case "LineTypeBorderColor":
                case "LineTypeBackgroundColor":
                case "LineTypeBorderWidth":
                case "LineTypeFocusBorderColor":
                case "LineTypeFocusBorderWidth":
                case "LineTypeCornerRadius":
                case "LineTypeContentPadding":
                case "LineTypeUnderlineOpacity":
                case "LineTypeUnderlineRippleOpacity":
                case "LineTypeUnderlineRippleWidth":
                case "LineTypeUnderlineRippleColor":
                case "LineTypeUnderlineColor":
                case "LineTypeHoverUnderlineColor":
                case "LineTypeUnderlineWidth":
                case "LineTypeHoverUnderlineWidth":
                case "LineTypeHoverUnderlineOpacity":
                case "LineTypeFocusUnderlineColor":
                case "LineTypeFocusUnderlineOpacity":
                case "LineTypeFocusUnderlineRippleOpacity":
                case "BoxTypeBorderColor":
                case "BoxTypeBackgroundColor":
                case "BoxTypeBorderWidth":
                case "BoxTypeFocusBorderColor":
                case "BoxTypeFocusBorderWidth":
                case "BoxTypeCornerRadius":
                case "BoxTypeContentPadding":
                case "BoxTypeUnderlineOpacity":
                case "BoxTypeUnderlineRippleOpacity":
                case "BoxTypeUnderlineRippleWidth":
                case "BoxTypeUnderlineRippleColor":
                case "BoxTypeUnderlineColor":
                case "BoxTypeHoverUnderlineColor":
                case "BoxTypeUnderlineWidth":
                case "BoxTypeHoverUnderlineWidth":
                case "BoxTypeHoverUnderlineOpacity":
                case "BoxTypeFocusUnderlineColor":
                case "BoxTypeFocusUnderlineOpacity":
                case "BoxTypeFocusUnderlineRippleOpacity":
                case "BorderTypeBorderColor":
                case "BorderTypeBackgroundColor":
                case "BorderTypeBorderWidth":
                case "BorderTypeFocusBorderColor":
                case "BorderTypeFocusBorderWidth":
                case "BorderTypeCornerRadius":
                case "BorderTypeContentPadding":
                case "BorderTypeUnderlineOpacity":
                case "BorderTypeUnderlineRippleOpacity":
                case "BorderTypeUnderlineRippleWidth":
                case "BorderTypeUnderlineRippleColor":
                case "BorderTypeUnderlineColor":
                case "BorderTypeHoverUnderlineColor":
                case "BorderTypeUnderlineWidth":
                case "BorderTypeHoverUnderlineWidth":
                case "BorderTypeHoverUnderlineOpacity":
                case "BorderTypeFocusUnderlineColor":
                case "BorderTypeFocusUnderlineOpacity":
                case "BorderTypeFocusUnderlineRippleOpacity":
                case "DisplayType":
                    this.me();
                    break;
                case "ActualDensity":
                    this.view.al();
                    this.me();
                    break;
                case "Density":
                    this.g = this.h == 0 ? 1 : this.h;
                    break;
                case "IsFocused":
                    this.l3();
                    this.md();
                    break;
                case "IsExpanded":
                    this.s = true;
                    this.ab = this.ae;
                    break;
                case "ActualIsExpanded":
                    this.ly();
                    break;
            }
        }
        static mt(a, b) {
            return new CornerRadius(1, !isNaN_(a.c) ? a.c : b.c, !isNaN_(a.d) ? a.d : b.d, !isNaN_(a.b) ? a.b : b.b, !isNaN_(a.a) ? a.a : b.a);
        }
        static s9(a, b) {
            return new Thickness(1, !isNaN_(a.c) ? a.c : b.c, !isNaN_(a.e) ? a.e : b.e, !isNaN_(a.d) ? a.d : b.d, !isNaN_(a.b) ? a.b : b.b);
        }
        mg() {
            this.lv((a) => {
                a.p = this.g;
                a.l = this.d == 0 ? 2 : this.d;
                switch (this.j) {
                    case 0:
                        a.r = 0;
                        break;
                    case 1:
                        a.r = 1;
                        break;
                    case 2:
                    case 3:
                        a.r = 2;
                        break;
                }
            });
        }
        mh() {
            this.lw((a) => {
                switch (this.j) {
                    case 0:
                        a.j = 0;
                        break;
                    case 1:
                        a.j = 1;
                        break;
                    case 2:
                    case 3:
                        a.j = 2;
                        break;
                }
            });
        }
        mf() {
            this.lu((a) => {
                a.l = this.g;
                switch (this.j) {
                    case 0:
                        a.p = 0;
                        break;
                    case 1:
                        a.p = 1;
                        break;
                    case 2:
                    case 3:
                        a.p = 2;
                        break;
                }
            });
        }
        mi() {
            this.lx((a) => {
                switch (this.j) {
                    case 0:
                        a.j = 0;
                        break;
                    case 1:
                        a.j = 1;
                        break;
                    case 2:
                    case 3:
                        a.j = 2;
                        break;
                }
            });
        }
        me() {
            this.mg();
            this.mf();
            this.mh();
            this.mi();
            switch (this.j) {
                case 0:
                    this.oj = this.oq != null ? this.oq : this.sl != null ? this.sl : this.qw;
                    this.oi = this.op != null ? this.op : this.sk != null ? this.sk : this.qv;
                    this.b6 = !isNaN_(this.cq) ? this.cq : !isNaN_(this.hd) ? this.hd : this.e6;
                    this.ok = this.sh != null ? this.sh : this.sm != null ? this.sm : this.qx;
                    this.b7 = !isNaN_(this.g8) ? this.g8 : !isNaN_(this.he) ? this.he : this.e7;
                    this.mq = InputGroup.mt(this.mu, InputGroup.mt(this.na, this.m3));
                    this.s6 = InputGroup.s9(this.ta, InputGroup.s9(this.tq, this.tj));
                    this.cc = !isNaN_(this.hx) ? this.hx : !isNaN_(this.hj) ? this.hj : this.fc;
                    this.cd = !isNaN_(this.hy) ? this.hy : !isNaN_(this.hk) ? this.hk : this.fd;
                    this.ce = !isNaN_(this.hz) ? this.hz : !isNaN_(this.hl) ? this.hl : this.fe;
                    this.oo = this.sz != null ? this.sz : this.sq != null ? this.sq : this.q2;
                    this.on = this.sy != null ? this.sy : this.sp != null ? this.sp : this.q1;
                    this.om = this.sj != null ? this.sj : this.so != null ? this.so : this.q0;
                    this.cf = !isNaN_(this.h0) ? this.h0 : !isNaN_(this.hm) ? this.hm : this.ff;
                    this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.hi) ? this.hi : this.fb;
                    this.ca = !isNaN_(this.hb) ? this.hb : !isNaN_(this.hh) ? this.hh : this.fa;
                    this.ol = this.si != null ? this.si : this.sn != null ? this.sn : this.qz;
                    this.b8 = !isNaN_(this.g9) ? this.g9 : !isNaN_(this.hf) ? this.hf : this.e8;
                    this.b9 = !isNaN_(this.ha) ? this.ha : !isNaN_(this.hg) ? this.hg : this.e9;
                    break;
                case 1:
                    this.oj = this.oq != null ? this.oq : this.oz != null ? this.oz : this.pg;
                    this.oi = this.op != null ? this.op : this.oy != null ? this.oy : this.pf;
                    this.b6 = !isNaN_(this.cq) ? this.cq : !isNaN_(this.cr) ? this.cr : this.dc;
                    this.ok = this.sh != null ? this.sh : this.o0 != null ? this.o0 : this.ph;
                    this.b7 = !isNaN_(this.g8) ? this.g8 : !isNaN_(this.cs) ? this.cs : this.dd;
                    this.mq = InputGroup.mt(this.mu, InputGroup.mt(this.ms, this.mw));
                    this.s6 = InputGroup.s9(this.ta, InputGroup.s9(this.s8, this.tc));
                    this.cc = !isNaN_(this.hx) ? this.hx : !isNaN_(this.cx) ? this.cx : this.di;
                    this.cd = !isNaN_(this.hy) ? this.hy : !isNaN_(this.cy) ? this.cy : this.dj;
                    this.ce = !isNaN_(this.hz) ? this.hz : !isNaN_(this.cz) ? this.cz : this.dk;
                    this.oo = this.sz != null ? this.sz : this.o4 != null ? this.o4 : this.pm;
                    this.on = this.sy != null ? this.sy : this.o3 != null ? this.o3 : this.pl;
                    this.om = this.sj != null ? this.sj : this.o2 != null ? this.o2 : this.pk;
                    this.cf = !isNaN_(this.h0) ? this.h0 : !isNaN_(this.c0) ? this.c0 : this.dl;
                    this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.cw) ? this.cw : this.dh;
                    this.ca = !isNaN_(this.hb) ? this.hb : !isNaN_(this.cv) ? this.cv : this.dg;
                    this.ol = this.si != null ? this.si : this.o1 != null ? this.o1 : this.pj;
                    this.b8 = !isNaN_(this.g9) ? this.g9 : !isNaN_(this.ct) ? this.ct : this.de;
                    this.b9 = !isNaN_(this.ha) ? this.ha : !isNaN_(this.cu) ? this.cu : this.df;
                    break;
                case 2:
                    this.oj = this.oq != null ? this.oq : this.os != null ? this.os : this.o8;
                    this.oi = this.op != null ? this.op : this.or != null ? this.or : this.o7;
                    this.b6 = !isNaN_(this.cq) ? this.cq : !isNaN_(this.cg) ? this.cg : this.c1;
                    this.ok = this.sh != null ? this.sh : this.ot != null ? this.ot : this.o9;
                    this.b7 = !isNaN_(this.g8) ? this.g8 : !isNaN_(this.ch) ? this.ch : this.c2;
                    this.mq = InputGroup.mt(this.mu, InputGroup.mt(this.mr, this.mv));
                    this.s6 = InputGroup.s9(this.ta, InputGroup.s9(this.s7, this.tb));
                    this.cc = !isNaN_(this.hx) ? this.hx : !isNaN_(this.cm) ? this.cm : this.c7;
                    this.cd = !isNaN_(this.hy) ? this.hy : !isNaN_(this.cn) ? this.cn : this.c8;
                    this.ce = !isNaN_(this.hz) ? this.hz : !isNaN_(this.co) ? this.co : this.c9;
                    this.oo = this.sz != null ? this.sz : this.ox != null ? this.ox : this.pe;
                    this.on = this.sy != null ? this.sy : this.ow != null ? this.ow : this.pd;
                    this.om = this.sj != null ? this.sj : this.ov != null ? this.ov : this.pc;
                    this.cf = !isNaN_(this.h0) ? this.h0 : !isNaN_(this.cp) ? this.cp : this.da;
                    this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.cl) ? this.cl : this.c6;
                    this.ca = !isNaN_(this.hb) ? this.hb : !isNaN_(this.ck) ? this.ck : this.c5;
                    this.ol = this.si != null ? this.si : this.ou != null ? this.ou : this.pb;
                    this.b8 = !isNaN_(this.g9) ? this.g9 : !isNaN_(this.ci) ? this.ci : this.c3;
                    this.b9 = !isNaN_(this.ha) ? this.ha : !isNaN_(this.cj) ? this.cj : this.c4;
                    break;
                case 3:
                    this.oj = this.oq != null ? this.oq : this.ss != null ? this.ss : this.r8;
                    this.oi = this.op != null ? this.op : this.sr != null ? this.sr : this.r7;
                    this.b6 = !isNaN_(this.cq) ? this.cq : !isNaN_(this.hn) ? this.hn : this.gu;
                    this.ok = this.sh != null ? this.sh : this.st != null ? this.st : this.r9;
                    this.b7 = !isNaN_(this.g8) ? this.g8 : !isNaN_(this.ho) ? this.ho : this.gv;
                    this.mq = InputGroup.mt(this.mu, InputGroup.mt(this.nb, this.m9));
                    this.s6 = InputGroup.s9(this.ta, InputGroup.s9(this.tr, this.tp));
                    this.cc = !isNaN_(this.hx) ? this.hx : !isNaN_(this.ht) ? this.ht : this.g0;
                    this.cd = !isNaN_(this.hy) ? this.hy : !isNaN_(this.hu) ? this.hu : this.g1;
                    this.ce = !isNaN_(this.hz) ? this.hz : !isNaN_(this.hv) ? this.hv : this.g2;
                    this.oo = this.sz != null ? this.sz : this.sx != null ? this.sx : this.se;
                    this.on = this.sy != null ? this.sy : this.sw != null ? this.sw : this.sd;
                    this.om = this.sj != null ? this.sj : this.sv != null ? this.sv : this.sc;
                    this.cf = !isNaN_(this.h0) ? this.h0 : !isNaN_(this.hw) ? this.hw : this.g3;
                    this.cb = !isNaN_(this.hc) ? this.hc : !isNaN_(this.hs) ? this.hs : this.gz;
                    this.ca = !isNaN_(this.hb) ? this.hb : !isNaN_(this.hr) ? this.hr : this.gy;
                    this.ol = this.si != null ? this.si : this.su != null ? this.su : this.sb;
                    this.b8 = !isNaN_(this.g9) ? this.g9 : !isNaN_(this.hp) ? this.hp : this.gw;
                    this.b9 = !isNaN_(this.ha) ? this.ha : !isNaN_(this.hq) ? this.hq : this.gx;
                    break;
            }
        }
        md() {
            this.lv((a) => {
            });
            this.lu((a) => {
            });
            let a = this.view.u;
            let b = this.view.t;
            let c = this.view.w;
            let d = this.view.x;
            let e = this.o != null && this.o.playState == 1;
            let f = this.p != null && this.p.playState == 1;
            let g = this.n != null && this.n.playState == 1;
            NativeUI.l(a, this.mq);
            NativeUI.l(b, this.mq);
            NativeUI.j(a, this.oi);
            NativeUI.u(a, this.s6);
            if (this.af) {
                if (!g) {
                    NativeUI.k(b, this.ok);
                    NativeUI.m(b, new Thickness(0, this.b7));
                }
                if (!f) {
                    NativeUI.j(c, this.ol);
                }
            }
            else {
                if (!f) {
                    if (this.ag) {
                        NativeUI.j(c, this.om);
                        NativeUI.t(c, this.ca);
                        NativeUI.q(c, this.cb);
                    }
                    else {
                        NativeUI.j(c, this.on);
                        NativeUI.t(c, this.cc);
                        NativeUI.q(c, this.cf);
                    }
                }
                if (!g) {
                    NativeUI.k(b, this.oj);
                    NativeUI.m(b, new Thickness(0, this.b6));
                }
                if (!f) {
                    NativeUI.j(a, this.oi);
                }
            }
            if (!e) {
                NativeUI.j(d, this.oo);
                NativeUI.q(d, this.ce);
                NativeUI.t(d, this.cd);
            }
        }
        get a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        }
        onChildrenMutated() {
            this.lu((a) => a.view.au());
            this.lv((a) => a.view.ac());
            this.lw((a) => a.view.q());
            this.lx((a) => a.view.q());
        }
        lt() {
            this.view.ab();
            let a = false;
            if (this.p == null) {
                this.p = KeyFrameAnimationFactory.f.c(this.view.c(this.a).m(new AnimationKeyFrameProperty(2, this.oj)).m(new AnimationKeyFrameProperty(2, this.ok)));
            }
            if (this.n == null) {
                this.n = KeyFrameAnimationFactory.f.c(this.view.a(this.a).m(new AnimationKeyFrameProperty(3, this.oj), new AnimationKeyFrameProperty(4, this.j == 2 || this.j == 3 ? new Thickness(0, this.b6) : new Thickness(0, 0))).m(new AnimationKeyFrameProperty(3, this.ok), new AnimationKeyFrameProperty(4, this.j == 2 || this.j == 3 ? new Thickness(0, this.b7) : new Thickness(0, 0))));
            }
            if (this.o == null) {
                this.o = KeyFrameAnimationFactory.f.c(this.view.b(this.a).m(new AnimationKeyFrameProperty(2, this.ok), new AnimationKeyFrameProperty(14, ((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 0.5;
                    $ret.m = 1;
                    return $ret;
                })())), new AnimationKeyFrameProperty(1, 0)).m(new AnimationKeyFrameProperty(2, this.ok), new AnimationKeyFrameProperty(14, ((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 1;
                    $ret.m = 1;
                    return $ret;
                })())), new AnimationKeyFrameProperty(1, 1)));
            }
        }
        get ac() {
            let a = false;
            this.lu((b) => {
                if (b.ak) {
                    a = true;
                }
            });
            return a;
        }
        l4() {
            this.ab = this.s ? this.ae : this.ac ? true : false;
            this.af = false;
            if (null != this.lostFocus) {
                this.lostFocus(this, EventArgs.empty);
            }
        }
        mc(a) {
            this.db = ThemeResolver.b(a, InputGroup.fq, InputGroup.dx);
            this.e1 = ThemeResolver.b(a, InputGroup.f1, InputGroup.d8);
            this.mx = ThemeResolver.d(a, InputGroup.m6, InputGroup.m0);
            this.td = ThemeResolver.f(a, InputGroup.tm, InputGroup.tg);
            this.o6 = ThemeResolver.e(a, InputGroup.q4, InputGroup.po);
            this.qr = ThemeResolver.e(a, InputGroup.rl, InputGroup.p5);
            this.qs = ThemeResolver.e(a, InputGroup.rm, InputGroup.p6);
            this.g7 = ThemeResolver.b(a, InputGroup.gt, InputGroup.e0);
            this.g6 = ThemeResolver.b(a, InputGroup.gs, InputGroup.ez);
            this.e5 = ThemeResolver.b(a, InputGroup.f5, InputGroup.ec);
            this.sf = ThemeResolver.e(a, InputGroup.r5, InputGroup.qp);
            this.sg = ThemeResolver.e(a, InputGroup.r6, InputGroup.qq);
            this.qu = ThemeResolver.e(a, InputGroup.ro, InputGroup.p8);
            this.qt = ThemeResolver.e(a, InputGroup.rn, InputGroup.p7);
            this.g4 = ThemeResolver.b(a, InputGroup.gq, InputGroup.ex);
            this.e4 = ThemeResolver.b(a, InputGroup.f4, InputGroup.eb);
            this.e2 = ThemeResolver.b(a, InputGroup.f2, InputGroup.d9);
            this.e3 = ThemeResolver.b(a, InputGroup.f3, InputGroup.ea);
            this.g5 = ThemeResolver.b(a, InputGroup.gr, InputGroup.ey);
            this.o5 = ThemeResolver.e(a, InputGroup.q3, InputGroup.pn);
            this.e6 = ThemeResolver.b(a, InputGroup.f6, InputGroup.ed);
            this.e7 = ThemeResolver.b(a, InputGroup.f7, InputGroup.ee);
            this.m3 = ThemeResolver.d(a, InputGroup.m7, InputGroup.m1);
            this.tj = ThemeResolver.f(a, InputGroup.tn, InputGroup.th);
            this.qw = ThemeResolver.e(a, InputGroup.rq, InputGroup.qa);
            this.qx = ThemeResolver.e(a, InputGroup.rr, InputGroup.qb);
            this.qy = ThemeResolver.e(a, InputGroup.rs, InputGroup.qc);
            this.ff = ThemeResolver.b(a, InputGroup.gf, InputGroup.em);
            this.fe = ThemeResolver.b(a, InputGroup.ge, InputGroup.el);
            this.fb = ThemeResolver.b(a, InputGroup.gb, InputGroup.ei);
            this.q1 = ThemeResolver.e(a, InputGroup.rv, InputGroup.qf);
            this.q2 = ThemeResolver.e(a, InputGroup.rw, InputGroup.qg);
            this.q0 = ThemeResolver.e(a, InputGroup.ru, InputGroup.qe);
            this.qz = ThemeResolver.e(a, InputGroup.rt, InputGroup.qd);
            this.fc = ThemeResolver.b(a, InputGroup.gc, InputGroup.ej);
            this.fa = ThemeResolver.b(a, InputGroup.ga, InputGroup.eh);
            this.e8 = ThemeResolver.b(a, InputGroup.f8, InputGroup.ef);
            this.e9 = ThemeResolver.b(a, InputGroup.f9, InputGroup.eg);
            this.fd = ThemeResolver.b(a, InputGroup.gd, InputGroup.ek);
            this.qv = ThemeResolver.e(a, InputGroup.rp, InputGroup.p9);
            this.dc = ThemeResolver.b(a, InputGroup.fr, InputGroup.dy);
            this.dd = ThemeResolver.b(a, InputGroup.fs, InputGroup.dz);
            this.mw = ThemeResolver.d(a, InputGroup.m5, InputGroup.mz);
            this.tc = ThemeResolver.f(a, InputGroup.tl, InputGroup.tf);
            this.pg = ThemeResolver.e(a, InputGroup.re, InputGroup.py);
            this.ph = ThemeResolver.e(a, InputGroup.rf, InputGroup.pz);
            this.pi = ThemeResolver.e(a, InputGroup.rg, InputGroup.p0);
            this.dl = ThemeResolver.b(a, InputGroup.f0, InputGroup.d7);
            this.dk = ThemeResolver.b(a, InputGroup.fz, InputGroup.d6);
            this.dh = ThemeResolver.b(a, InputGroup.fw, InputGroup.d3);
            this.pl = ThemeResolver.e(a, InputGroup.rj, InputGroup.p3);
            this.pm = ThemeResolver.e(a, InputGroup.rk, InputGroup.p4);
            this.pk = ThemeResolver.e(a, InputGroup.ri, InputGroup.p2);
            this.pj = ThemeResolver.e(a, InputGroup.rh, InputGroup.p1);
            this.di = ThemeResolver.b(a, InputGroup.fx, InputGroup.d4);
            this.dg = ThemeResolver.b(a, InputGroup.fv, InputGroup.d2);
            this.de = ThemeResolver.b(a, InputGroup.ft, InputGroup.d0);
            this.df = ThemeResolver.b(a, InputGroup.fu, InputGroup.d1);
            this.dj = ThemeResolver.b(a, InputGroup.fy, InputGroup.d5);
            this.pf = ThemeResolver.e(a, InputGroup.rd, InputGroup.px);
            this.c1 = ThemeResolver.b(a, InputGroup.fg, InputGroup.dm);
            this.c2 = ThemeResolver.b(a, InputGroup.fh, InputGroup.dn);
            this.mv = ThemeResolver.d(a, InputGroup.m4, InputGroup.my);
            this.tb = ThemeResolver.f(a, InputGroup.tk, InputGroup.te);
            this.o8 = ThemeResolver.e(a, InputGroup.q6, InputGroup.pq);
            this.o9 = ThemeResolver.e(a, InputGroup.q7, InputGroup.pr);
            this.pa = ThemeResolver.e(a, InputGroup.q8, InputGroup.ps);
            this.da = ThemeResolver.b(a, InputGroup.fp, InputGroup.dw);
            this.c9 = ThemeResolver.b(a, InputGroup.fo, InputGroup.dv);
            this.c6 = ThemeResolver.b(a, InputGroup.fl, InputGroup.ds);
            this.pd = ThemeResolver.e(a, InputGroup.rb, InputGroup.pv);
            this.pe = ThemeResolver.e(a, InputGroup.rc, InputGroup.pw);
            this.pc = ThemeResolver.e(a, InputGroup.ra, InputGroup.pu);
            this.pb = ThemeResolver.e(a, InputGroup.q9, InputGroup.pt);
            this.c7 = ThemeResolver.b(a, InputGroup.fm, InputGroup.dt);
            this.c5 = ThemeResolver.b(a, InputGroup.fk, InputGroup.dr);
            this.c3 = ThemeResolver.b(a, InputGroup.fi, InputGroup.dp);
            this.c4 = ThemeResolver.b(a, InputGroup.fj, InputGroup.dq);
            this.c8 = ThemeResolver.b(a, InputGroup.fn, InputGroup.du);
            this.o7 = ThemeResolver.e(a, InputGroup.q5, InputGroup.pp);
            this.gu = ThemeResolver.b(a, InputGroup.gg, InputGroup.en);
            this.gv = ThemeResolver.b(a, InputGroup.gh, InputGroup.eo);
            this.m9 = ThemeResolver.d(a, InputGroup.m8, InputGroup.m2);
            this.tp = ThemeResolver.f(a, InputGroup.to, InputGroup.ti);
            this.r8 = ThemeResolver.e(a, InputGroup.ry, InputGroup.qi);
            this.r9 = ThemeResolver.e(a, InputGroup.rz, InputGroup.qj);
            this.sa = ThemeResolver.e(a, InputGroup.r0, InputGroup.qk);
            this.g3 = ThemeResolver.b(a, InputGroup.gp, InputGroup.ew);
            this.g2 = ThemeResolver.b(a, InputGroup.go, InputGroup.ev);
            this.gz = ThemeResolver.b(a, InputGroup.gl, InputGroup.es);
            this.sd = ThemeResolver.e(a, InputGroup.r3, InputGroup.qn);
            this.se = ThemeResolver.e(a, InputGroup.r4, InputGroup.qo);
            this.sc = ThemeResolver.e(a, InputGroup.r2, InputGroup.qm);
            this.sb = ThemeResolver.e(a, InputGroup.r1, InputGroup.ql);
            this.g0 = ThemeResolver.b(a, InputGroup.gm, InputGroup.et);
            this.gy = ThemeResolver.b(a, InputGroup.gk, InputGroup.er);
            this.gw = ThemeResolver.b(a, InputGroup.gi, InputGroup.ep);
            this.gx = ThemeResolver.b(a, InputGroup.gj, InputGroup.eq);
            this.g1 = ThemeResolver.b(a, InputGroup.gn, InputGroup.eu);
            this.r7 = ThemeResolver.e(a, InputGroup.rx, InputGroup.qh);
        }
        ly() {
            this.lt();
            if (this.ab) {
                this.lv((a) => a.am = true);
            }
            else {
                this.lv((a) => a.am = false);
            }
        }
        l3() {
            this.lt();
            if (this.af) {
                let a = 1;
                this.lv((b) => b.ak = true);
                this.l7(a);
            }
            else {
                let b = -1;
                this.lv((c) => c.ak = false);
                this.l7(b);
            }
        }
        l2() {
            this.ab = this.s ? this.ae : true;
            this.af = true;
            if (null != this.gotFocus) {
                this.gotFocus(this, EventArgs.empty);
            }
        }
        mj() {
            if (this.s) {
                this.ab = this.s;
            }
            else if (this.af) {
                this.ab = true;
            }
            else {
                this.ab = this.ac ? true : false;
            }
        }
        l7(a) {
            if ((a > 0 && this.p.playbackRate < 0) || (a < 0 && this.p.playbackRate > 0)) {
                this.p.reverse();
                this.p.finished.f((b) => {
                    if (this.p != null) {
                        this.p.commitStyles();
                    }
                    if (this.aa) {
                        this.p = null;
                        this.aa = false;
                    }
                });
                this.n.reverse();
                this.n.finished.f((b) => {
                    if (this.n != null) {
                        this.n.commitStyles();
                    }
                    if (this.r) {
                        this.n = null;
                        this.r = false;
                    }
                });
                this.o.reverse();
                this.o.finished.f((b) => {
                    if (this.o != null) {
                        this.o.commitStyles();
                    }
                    if (this.z) {
                        this.o = null;
                        this.z = false;
                    }
                });
            }
            else {
                this.p.play();
                this.p.finished.f((b) => {
                    if (this.p != null) {
                        this.p.commitStyles();
                    }
                    if (this.aa) {
                        this.p = null;
                        this.aa = false;
                    }
                });
                this.n.play();
                this.n.finished.f((b) => {
                    if (this.n != null) {
                        this.n.commitStyles();
                    }
                    if (this.r) {
                        this.n = null;
                        this.r = false;
                    }
                });
                this.o.play();
                this.o.finished.f((b) => {
                    if (this.o != null) {
                        this.o.commitStyles();
                    }
                    if (this.z) {
                        this.o = null;
                        this.z = false;
                    }
                });
            }
        }
        get oj() {
            return this.nd;
        }
        set oj(a) {
            let b = this.nd;
            this.nd = a;
            if (b != this.nd) {
                this.l5("ActualBorderColor", b, a);
            }
        }
        get ok() {
            return this.ne;
        }
        set ok(a) {
            let b = this.ne;
            this.ne = a;
            if (b != this.ne) {
                this.l5("ActualFocusBorderColor", b, a);
            }
        }
        get b6() {
            return this.ai;
        }
        set b6(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.l5("ActualBorderWidth", b, a);
            }
        }
        get b7() {
            return this.aj;
        }
        set b7(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.l5("ActualFocusBorderWidth", b, a);
            }
        }
        get mq() {
            return this.mk;
        }
        set mq(a) {
            let b = this.mk;
            this.mk = a;
            if (b != this.mk) {
                this.l5("ActualCornerRadius", b, a);
            }
        }
        get s6() {
            return this.s0;
        }
        set s6(a) {
            let b = this.s0;
            this.s0 = a;
            if (b != this.s0) {
                this.l5("ActualContentPadding", b, a);
            }
        }
        get cf() {
            return this.ar;
        }
        set cf(a) {
            let b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.l5("ActualUnderlineWidth", b, a);
            }
        }
        get ce() {
            return this.aq;
        }
        set ce(a) {
            let b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.l5("ActualUnderlineRippleWidth", b, a);
            }
        }
        get cb() {
            return this.an;
        }
        set cb(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.l5("ActualHoverUnderlineWidth", b, a);
            }
        }
        get on() {
            return this.nh;
        }
        set on(a) {
            let b = this.nh;
            this.nh = a;
            if (b != this.nh) {
                this.l5("ActualUnderlineColor", b, a);
            }
        }
        get oo() {
            return this.ni;
        }
        set oo(a) {
            let b = this.ni;
            this.ni = a;
            if (b != this.ni) {
                this.l5("ActualUnderlineRippleColor", b, a);
            }
        }
        get om() {
            return this.ng;
        }
        set om(a) {
            let b = this.ng;
            this.ng = a;
            if (b != this.ng) {
                this.l5("ActualHoverUnderlineColor", b, a);
            }
        }
        get ol() {
            return this.nf;
        }
        set ol(a) {
            let b = this.nf;
            this.n0 = a;
            if (b != this.nf) {
                this.l5("ActualFocusUnderlineColor", b, a);
            }
        }
        get cc() {
            return this.ao;
        }
        set cc(a) {
            let b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.l5("ActualUnderlineOpacity", b, a);
            }
        }
        get ca() {
            return this.am;
        }
        set ca(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.l5("ActualHoverUnderlineOpacity", b, a);
            }
        }
        get b8() {
            return this.ak;
        }
        set b8(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.l5("ActualFocusUnderlineOpacity", b, a);
            }
        }
        get b9() {
            return this.al;
        }
        set b9(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.l5("ActualFocusUnderlineRippleOpacity", b, a);
            }
        }
        get cd() {
            return this.ap;
        }
        set cd(a) {
            let b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.l5("ActualUnderlineRippleOpacity", b, a);
            }
        }
        get oi() {
            return this.nc;
        }
        set oi(a) {
            let b = this.nc;
            this.nc = a;
            if (b != this.nc) {
                this.l5("ActualBackgroundColor", b, a);
            }
        }
        get cq() {
            return this.a2;
        }
        set cq(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.l5("BorderWidth", b, a);
            }
        }
        get g8() {
            return this.bd;
        }
        set g8(a) {
            let b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.l5("FocusBorderWidth", b, a);
            }
        }
        get oq() {
            return this.nk;
        }
        set oq(a) {
            let b = this.nk;
            this.nk = a;
            if (b != this.nk) {
                this.l5("BorderColor", b, a);
            }
        }
        get mu() {
            return this.mn;
        }
        set mu(a) {
            let b = this.mn;
            this.mn = a;
            if (b != this.mn) {
                this.l5("CornerRadius", b, a);
            }
        }
        get ta() {
            return this.s3;
        }
        set ta(a) {
            let b = this.s3;
            this.s3 = a;
            if (b != this.s3) {
                this.l5("ContentPadding", b, a);
            }
        }
        get h0() {
            return this.b5;
        }
        set h0(a) {
            let b = this.b5;
            this.b5 = a;
            if (b != this.b5) {
                this.l5("UnderlineWidth", b, a);
            }
        }
        get hz() {
            return this.b4;
        }
        set hz(a) {
            let b = this.b4;
            this.b4 = a;
            if (b != this.b4) {
                this.l5("UnderlineRippleWidth", b, a);
            }
        }
        get hc() {
            return this.bh;
        }
        set hc(a) {
            let b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.l5("HoverUnderlineWidth", b, a);
            }
        }
        get sy() {
            return this.og;
        }
        set sy(a) {
            let b = this.og;
            this.og = a;
            if (b != this.og) {
                this.l5("UnderlineColor", b, a);
            }
        }
        get sz() {
            return this.oh;
        }
        set sz(a) {
            let b = this.oh;
            this.oh = a;
            if (b != this.oh) {
                this.l5("UnderlineRippleColor", b, a);
            }
        }
        get sj() {
            return this.n1;
        }
        set sj(a) {
            let b = this.n1;
            this.n1 = a;
            if (b != this.n1) {
                this.l5("HoverUnderlineColor", b, a);
            }
        }
        get si() {
            return this.n0;
        }
        set si(a) {
            let b = this.n0;
            this.n0 = a;
            if (b != this.n0) {
                this.l5("FocusUnderlineColor", b, a);
            }
        }
        get hx() {
            return this.b2;
        }
        set hx(a) {
            let b = this.b2;
            this.b2 = a;
            if (b != this.b2) {
                this.l5("UnderlineOpacity", b, a);
            }
        }
        get hb() {
            return this.bg;
        }
        set hb(a) {
            let b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.l5("HoverUnderlineOpacity", b, a);
            }
        }
        get g9() {
            return this.be;
        }
        set g9(a) {
            let b = this.be;
            this.be = a;
            if (b != this.be) {
                this.l5("FocusUnderlineOpacity", b, a);
            }
        }
        get ha() {
            return this.bf;
        }
        set ha(a) {
            let b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.l5("FocusUnderlineRippleOpacity", b, a);
            }
        }
        get hy() {
            return this.b3;
        }
        set hy(a) {
            let b = this.b3;
            this.b3 = a;
            if (b != this.b3) {
                this.l5("UnderlineRippleOpacity", b, a);
            }
        }
        get op() {
            return this.nj;
        }
        set op(a) {
            let b = this.nj;
            this.nj = a;
            if (b != this.nj) {
                this.l5("BackgroundColor", b, a);
            }
        }
        get hd() {
            return this.bi;
        }
        set hd(a) {
            let b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.l5("LineTypeBorderWidth", b, a);
            }
        }
        get he() {
            return this.bj;
        }
        set he(a) {
            let b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.l5("LineTypeFocusBorderWidth", b, a);
            }
        }
        get sm() {
            return this.n4;
        }
        set sm(a) {
            let b = this.n4;
            this.n4 = a;
            if (b != this.n4) {
                this.l5("LineTypeFocusBorderColor", b, a);
            }
        }
        get sl() {
            return this.n3;
        }
        set sl(a) {
            let b = this.n3;
            this.n3 = a;
            if (b != this.n3) {
                this.l5("LineTypeBorderColor", b, a);
            }
        }
        get na() {
            return this.mo;
        }
        set na(a) {
            let b = this.mo;
            this.mo = a;
            if (b != this.mo) {
                this.l5("LineTypeCornerRadius", b, a);
            }
        }
        get tq() {
            return this.s4;
        }
        set tq(a) {
            let b = this.s4;
            this.s4 = a;
            if (b != this.s4) {
                this.l5("LineTypeContentPadding", b, a);
            }
        }
        get hm() {
            return this.br;
        }
        set hm(a) {
            let b = this.br;
            this.br = a;
            if (b != this.br) {
                this.l5("LineTypeUnderlineWidth", b, a);
            }
        }
        get hl() {
            return this.bq;
        }
        set hl(a) {
            let b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.l5("LineTypeUnderlineRippleWidth", b, a);
            }
        }
        get hi() {
            return this.bn;
        }
        set hi(a) {
            let b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.l5("LineTypeHoverUnderlineWidth", b, a);
            }
        }
        get sp() {
            return this.n7;
        }
        set sp(a) {
            let b = this.n7;
            this.n7 = a;
            if (b != this.n7) {
                this.l5("LineTypeUnderlineColor", b, a);
            }
        }
        get sq() {
            return this.n8;
        }
        set sq(a) {
            let b = this.n8;
            this.n8 = a;
            if (b != this.n8) {
                this.l5("LineTypeUnderlineRippleColor", b, a);
            }
        }
        get so() {
            return this.n6;
        }
        set so(a) {
            let b = this.n6;
            this.n1 = a;
            if (b != this.n6) {
                this.l5("LineTypeHoverUnderlineColor", b, a);
            }
        }
        get sn() {
            return this.n5;
        }
        set sn(a) {
            let b = this.n5;
            this.n5 = a;
            if (b != this.n5) {
                this.l5("LineTypeFocusUnderlineColor", b, a);
            }
        }
        get hj() {
            return this.bo;
        }
        set hj(a) {
            let b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.l5("LineTypeUnderlineOpacity", b, a);
            }
        }
        get hh() {
            return this.bm;
        }
        set hh(a) {
            let b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.l5("LineTypeHoverUnderlineOpacity", b, a);
            }
        }
        get hf() {
            return this.bk;
        }
        set hf(a) {
            let b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.l5("LineTypeFocusUnderlineOpacity", b, a);
            }
        }
        get hg() {
            return this.bl;
        }
        set hg(a) {
            let b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.l5("LineTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get hk() {
            return this.bp;
        }
        set hk(a) {
            let b = this.bp;
            this.bp = a;
            if (b != this.bp) {
                this.l5("LineTypeUnderlineRippleOpacity", b, a);
            }
        }
        get sk() {
            return this.n2;
        }
        set sk(a) {
            let b = this.n2;
            this.n2 = a;
            if (b != this.n2) {
                this.l5("LineTypeBackgroundColor", b, a);
            }
        }
        get cr() {
            return this.a3;
        }
        set cr(a) {
            let b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.l5("BoxTypeBorderWidth", b, a);
            }
        }
        get cs() {
            return this.a4;
        }
        set cs(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.l5("BoxTypeFocusBorderWidth", b, a);
            }
        }
        get o0() {
            return this.nu;
        }
        set o0(a) {
            let b = this.nu;
            this.nu = a;
            if (b != this.nu) {
                this.l5("BoxTypeFocusBorderColor", b, a);
            }
        }
        get oz() {
            return this.nt;
        }
        set oz(a) {
            let b = this.nt;
            this.nt = a;
            if (b != this.nt) {
                this.l5("BoxTypeBorderColor", b, a);
            }
        }
        get ms() {
            return this.mm;
        }
        set ms(a) {
            let b = this.mm;
            this.mm = a;
            if (b != this.mm) {
                this.l5("BoxTypeCornerRadius", b, a);
            }
        }
        get s8() {
            return this.s2;
        }
        set s8(a) {
            let b = this.s2;
            this.s2 = a;
            if (b != this.s2) {
                this.l5("BoxTypeContentPadding", b, a);
            }
        }
        get c0() {
            return this.bc;
        }
        set c0(a) {
            let b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.l5("BoxTypeUnderlineWidth", b, a);
            }
        }
        get cz() {
            return this.bb;
        }
        set cz(a) {
            let b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.l5("BoxTypeUnderlineRippleWidth", b, a);
            }
        }
        get cw() {
            return this.a8;
        }
        set cw(a) {
            let b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.l5("BoxTypeHoverUnderlineWidth", b, a);
            }
        }
        get o3() {
            return this.nx;
        }
        set o3(a) {
            let b = this.nx;
            this.nx = a;
            if (b != this.nx) {
                this.l5("BoxTypeUnderlineColor", b, a);
            }
        }
        get o4() {
            return this.ny;
        }
        set o4(a) {
            let b = this.ny;
            this.ny = a;
            if (b != this.ny) {
                this.l5("BoxTypeUnderlineRippleColor", b, a);
            }
        }
        get o2() {
            return this.nw;
        }
        set o2(a) {
            let b = this.nw;
            this.n1 = a;
            if (b != this.nw) {
                this.l5("BoxTypeHoverUnderlineColor", b, a);
            }
        }
        get o1() {
            return this.nv;
        }
        set o1(a) {
            let b = this.nv;
            this.nv = a;
            if (b != this.nv) {
                this.l5("BoxTypeFocusUnderlineColor", b, a);
            }
        }
        get cx() {
            return this.a9;
        }
        set cx(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.l5("BoxTypeUnderlineOpacity", b, a);
            }
        }
        get cv() {
            return this.a7;
        }
        set cv(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.l5("BoxTypeHoverUnderlineOpacity", b, a);
            }
        }
        get ct() {
            return this.a5;
        }
        set ct(a) {
            let b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.l5("BoxTypeFocusUnderlineOpacity", b, a);
            }
        }
        get cu() {
            return this.a6;
        }
        set cu(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.l5("BoxTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get cy() {
            return this.ba;
        }
        set cy(a) {
            let b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.l5("BoxTypeUnderlineRippleOpacity", b, a);
            }
        }
        get oy() {
            return this.ns;
        }
        set oy(a) {
            let b = this.ns;
            this.ns = a;
            if (b != this.ns) {
                this.l5("BoxTypeBackgroundColor", b, a);
            }
        }
        get cg() {
            return this.as;
        }
        set cg(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.l5("BorderTypeBorderWidth", b, a);
            }
        }
        get ch() {
            return this.at;
        }
        set ch(a) {
            let b = this.at;
            this.at = a;
            if (b != this.at) {
                this.l5("BorderTypeFocusBorderWidth", b, a);
            }
        }
        get ot() {
            return this.nn;
        }
        set ot(a) {
            let b = this.nn;
            this.nn = a;
            if (b != this.nn) {
                this.l5("BorderTypeFocusBorderColor", b, a);
            }
        }
        get os() {
            return this.nm;
        }
        set os(a) {
            let b = this.nm;
            this.nm = a;
            if (b != this.nm) {
                this.l5("BorderTypeBorderColor", b, a);
            }
        }
        get mr() {
            return this.ml;
        }
        set mr(a) {
            let b = this.ml;
            this.ml = a;
            if (b != this.ml) {
                this.l5("BorderTypeCornerRadius", b, a);
            }
        }
        get s7() {
            return this.s1;
        }
        set s7(a) {
            let b = this.s1;
            this.s1 = a;
            if (b != this.s1) {
                this.l5("BorderTypeContentPadding", b, a);
            }
        }
        get cp() {
            return this.a1;
        }
        set cp(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.l5("BorderTypeUnderlineWidth", b, a);
            }
        }
        get co() {
            return this.a0;
        }
        set co(a) {
            let b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.l5("BorderTypeUnderlineRippleWidth", b, a);
            }
        }
        get cl() {
            return this.ax;
        }
        set cl(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.l5("BorderTypeHoverUnderlineWidth", b, a);
            }
        }
        get ow() {
            return this.nq;
        }
        set ow(a) {
            let b = this.nq;
            this.nq = a;
            if (b != this.nq) {
                this.l5("BorderTypeUnderlineColor", b, a);
            }
        }
        get ox() {
            return this.nr;
        }
        set ox(a) {
            let b = this.nr;
            this.nr = a;
            if (b != this.nr) {
                this.l5("BorderTypeUnderlineRippleColor", b, a);
            }
        }
        get ov() {
            return this.np;
        }
        set ov(a) {
            let b = this.np;
            this.n1 = a;
            if (b != this.np) {
                this.l5("BorderTypeHoverUnderlineColor", b, a);
            }
        }
        get ou() {
            return this.no;
        }
        set ou(a) {
            let b = this.no;
            this.no = a;
            if (b != this.no) {
                this.l5("BorderTypeFocusUnderlineColor", b, a);
            }
        }
        get cm() {
            return this.ay;
        }
        set cm(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.l5("BorderTypeUnderlineOpacity", b, a);
            }
        }
        get ck() {
            return this.aw;
        }
        set ck(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.l5("BorderTypeHoverUnderlineOpacity", b, a);
            }
        }
        get ci() {
            return this.au;
        }
        set ci(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.l5("BorderTypeFocusUnderlineOpacity", b, a);
            }
        }
        get cj() {
            return this.av;
        }
        set cj(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.l5("BorderTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get cn() {
            return this.az;
        }
        set cn(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.l5("BorderTypeUnderlineRippleOpacity", b, a);
            }
        }
        get or() {
            return this.nl;
        }
        set or(a) {
            let b = this.nl;
            this.nl = a;
            if (b != this.nl) {
                this.l5("BorderTypeBackgroundColor", b, a);
            }
        }
        get hn() {
            return this.bs;
        }
        set hn(a) {
            let b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.l5("SearchTypeBorderWidth", b, a);
            }
        }
        get ho() {
            return this.bt;
        }
        set ho(a) {
            let b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.l5("SearchTypeFocusBorderWidth", b, a);
            }
        }
        get st() {
            return this.ob;
        }
        set st(a) {
            let b = this.ob;
            this.ob = a;
            if (b != this.ob) {
                this.l5("SearchTypeFocusBorderColor", b, a);
            }
        }
        get ss() {
            return this.oa;
        }
        set ss(a) {
            let b = this.oa;
            this.oa = a;
            if (b != this.oa) {
                this.l5("SearchTypeBorderColor", b, a);
            }
        }
        get nb() {
            return this.mp;
        }
        set nb(a) {
            let b = this.mp;
            this.mp = a;
            if (b != this.mp) {
                this.l5("SearchTypeCornerRadius", b, a);
            }
        }
        get tr() {
            return this.s5;
        }
        set tr(a) {
            let b = this.s5;
            this.s5 = a;
            if (b != this.s5) {
                this.l5("SearchTypeContentPadding", b, a);
            }
        }
        get hw() {
            return this.b1;
        }
        set hw(a) {
            let b = this.b1;
            this.b1 = a;
            if (b != this.b1) {
                this.l5("SearchTypeUnderlineWidth", b, a);
            }
        }
        get hv() {
            return this.b0;
        }
        set hv(a) {
            let b = this.b0;
            this.b0 = a;
            if (b != this.b0) {
                this.l5("SearchTypeUnderlineRippleWidth", b, a);
            }
        }
        get hs() {
            return this.bx;
        }
        set hs(a) {
            let b = this.bx;
            this.bx = a;
            if (b != this.bx) {
                this.l5("SearchTypeHoverUnderlineWidth", b, a);
            }
        }
        get sw() {
            return this.oe;
        }
        set sw(a) {
            let b = this.oe;
            this.oe = a;
            if (b != this.oe) {
                this.l5("SearchTypeUnderlineColor", b, a);
            }
        }
        get sx() {
            return this.of;
        }
        set sx(a) {
            let b = this.of;
            this.of = a;
            if (b != this.of) {
                this.l5("SearchTypeUnderlineRippleColor", b, a);
            }
        }
        get sv() {
            return this.od;
        }
        set sv(a) {
            let b = this.od;
            this.n1 = a;
            if (b != this.od) {
                this.l5("SearchTypeHoverUnderlineColor", b, a);
            }
        }
        get su() {
            return this.oc;
        }
        set su(a) {
            let b = this.oc;
            this.oc = a;
            if (b != this.oc) {
                this.l5("SearchTypeFocusUnderlineColor", b, a);
            }
        }
        get ht() {
            return this.by;
        }
        set ht(a) {
            let b = this.by;
            this.by = a;
            if (b != this.by) {
                this.l5("SearchTypeUnderlineOpacity", b, a);
            }
        }
        get hr() {
            return this.bw;
        }
        set hr(a) {
            let b = this.bw;
            this.bw = a;
            if (b != this.bw) {
                this.l5("SearchTypeHoverUnderlineOpacity", b, a);
            }
        }
        get hp() {
            return this.bu;
        }
        set hp(a) {
            let b = this.bu;
            this.bu = a;
            if (b != this.bu) {
                this.l5("SearchTypeFocusUnderlineOpacity", b, a);
            }
        }
        get hq() {
            return this.bv;
        }
        set hq(a) {
            let b = this.bv;
            this.bv = a;
            if (b != this.bv) {
                this.l5("SearchTypeFocusUnderlineRippleOpacity", b, a);
            }
        }
        get hu() {
            return this.bz;
        }
        set hu(a) {
            let b = this.bz;
            this.bz = a;
            if (b != this.bz) {
                this.l5("SearchTypeUnderlineRippleOpacity", b, a);
            }
        }
        get sr() {
            return this.n9;
        }
        set sr(a) {
            let b = this.n9;
            this.n9 = a;
            if (b != this.n9) {
                this.l5("SearchTypeBackgroundColor", b, a);
            }
        }
        get ae() {
            return this.w;
        }
        set ae(a) {
            let b = this.w;
            this.w = a;
            if (b != this.w) {
                this.l5("IsExpanded", b, a);
            }
        }
        mb() {
            this.w = false;
            this.s = false;
            this.mj();
        }
        get ag() {
            return this.y;
        }
        set ag(a) {
            let b = this.y;
            this.y = a;
            if (b != this.y) {
                this.l5("IsHovered", b, a);
            }
        }
        get af() {
            return this.x;
        }
        set af(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.l5("IsFocused", b, a);
            }
        }
        get ab() {
            return this.q;
        }
        set ab(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.l5("ActualIsExpanded", b, a);
            }
        }
        get sh() {
            return this.nz;
        }
        set sh(a) {
            let b = this.nz;
            this.nz = a;
            if (b != this.nz) {
                this.l5("FocusBorderColor", b, a);
            }
        }
        get ka() {
            return this.h4;
        }
        set ka(a) {
            let b = this.h4;
            this.h4 = a;
            if (b != this.h4) {
                this.l5("Id", b, a);
            }
        }
        get disabled() {
            return this.v;
        }
        set disabled(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.l5("IsDisabled", b, a);
            }
        }
        l6() {
        }
        onDetachedFromUI() {
            this.view.ae();
        }
        onAttachedToUI() {
            this.view.ac();
        }
        ah() {
            return this.view.g();
        }
        provideContainer(a) {
            this.view.ad(a);
        }
        get inputs() {
            return this.k;
        }
    }
    InputGroup.$t = /*@__PURE__*/ markType(InputGroup, 'InputGroup', Base.$, [INotifyPropertyChanged_$type]);
    InputGroup.c = 2;
    InputGroup.fq = 0;
    InputGroup.f1 = 0;
    InputGroup.m6 = /*@__PURE__*/ new CornerRadius(1, 0, 0, 0, 0);
    InputGroup.tm = /*@__PURE__*/ new Thickness(1, 0, 0, 0, 0);
    InputGroup.q4 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rl = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.rm = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.gt = 1;
    InputGroup.gs = 2;
    InputGroup.f5 = 2;
    InputGroup.r5 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.r6 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.ro = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rn = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.gq = 1;
    InputGroup.f4 = 1;
    InputGroup.f2 = 1;
    InputGroup.f3 = 1;
    InputGroup.gr = 0;
    InputGroup.q3 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.f6 = 0;
    InputGroup.f7 = 0;
    InputGroup.m7 = /*@__PURE__*/ new CornerRadius(1, 0, 0, 0, 0);
    InputGroup.tn = /*@__PURE__*/ new Thickness(1, 0, 0, 0, 0);
    InputGroup.rq = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rr = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.rs = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.gf = 1;
    InputGroup.ge = 2;
    InputGroup.gb = 2;
    InputGroup.rv = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rw = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.ru = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rt = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.gc = 1;
    InputGroup.ga = 1;
    InputGroup.f8 = 1;
    InputGroup.f9 = 1;
    InputGroup.gd = 0;
    InputGroup.rp = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.fr = 0;
    InputGroup.fs = 0;
    InputGroup.m5 = /*@__PURE__*/ new CornerRadius(1, 4, 4, 0, 0);
    InputGroup.tl = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    InputGroup.re = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rf = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.rg = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.f0 = 1;
    InputGroup.fz = 2;
    InputGroup.fw = 2;
    InputGroup.rj = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rk = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.ri = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rh = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.fx = 1;
    InputGroup.fv = 1;
    InputGroup.ft = 1;
    InputGroup.fu = 1;
    InputGroup.fy = 0;
    InputGroup.rd = /*@__PURE__*/ BrushUtil.g(20, 0, 0, 0);
    InputGroup.fg = 1;
    InputGroup.fh = 2;
    InputGroup.m4 = /*@__PURE__*/ new CornerRadius(1, 4, 4, 4, 4);
    InputGroup.tk = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    InputGroup.q6 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.q7 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.q8 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.fp = 1;
    InputGroup.fo = 2;
    InputGroup.fl = 2;
    InputGroup.rb = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rc = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.ra = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.q9 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.fm = 0;
    InputGroup.fk = 0;
    InputGroup.fi = 0;
    InputGroup.fj = 0;
    InputGroup.fn = 0;
    InputGroup.q5 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.gg = 1;
    InputGroup.gh = 2;
    InputGroup.m8 = /*@__PURE__*/ new CornerRadius(1, 4, 4, 4, 4);
    InputGroup.to = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    InputGroup.ry = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.rz = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.r0 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.gp = 1;
    InputGroup.go = 2;
    InputGroup.gl = 2;
    InputGroup.r3 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.r4 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.r2 = /*@__PURE__*/ BrushUtil.g(138, 0, 0, 0);
    InputGroup.r1 = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    InputGroup.gm = 0;
    InputGroup.gk = 0;
    InputGroup.gi = 0;
    InputGroup.gj = 0;
    InputGroup.gn = 0;
    InputGroup.rx = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.dx = 0;
    InputGroup.d8 = 0;
    InputGroup.m0 = /*@__PURE__*/ new CornerRadius(1, 0, 0, 0, 0);
    InputGroup.tg = /*@__PURE__*/ new Thickness(1, 0, 0, 0, 0);
    InputGroup.po = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.p5 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.p6 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.e0 = 1;
    InputGroup.ez = 2;
    InputGroup.ec = 2;
    InputGroup.qp = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.qq = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.p8 = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.p7 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.ex = 1;
    InputGroup.eb = 1;
    InputGroup.d9 = 1;
    InputGroup.ea = 1;
    InputGroup.ey = 0;
    InputGroup.pn = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.ed = 0;
    InputGroup.ee = 0;
    InputGroup.m1 = /*@__PURE__*/ new CornerRadius(1, 0, 0, 0, 0);
    InputGroup.th = /*@__PURE__*/ new Thickness(1, 0, 0, 0, 0);
    InputGroup.qa = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.qb = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.qc = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.em = 1;
    InputGroup.el = 2;
    InputGroup.ei = 2;
    InputGroup.qf = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.qg = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.qe = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.qd = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.ej = 1;
    InputGroup.eh = 1;
    InputGroup.ef = 1;
    InputGroup.eg = 1;
    InputGroup.ek = 0;
    InputGroup.p9 = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.dy = 0;
    InputGroup.dz = 0;
    InputGroup.mz = /*@__PURE__*/ new CornerRadius(1, 4, 4, 0, 0);
    InputGroup.tf = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    InputGroup.py = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.pz = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.p0 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.d7 = 1;
    InputGroup.d6 = 2;
    InputGroup.d3 = 2;
    InputGroup.p3 = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.p4 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.p2 = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.p1 = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.d4 = 1;
    InputGroup.d2 = 1;
    InputGroup.d0 = 1;
    InputGroup.d1 = 1;
    InputGroup.d5 = 0;
    InputGroup.px = /*@__PURE__*/ BrushUtil.g(20, 0, 0, 0);
    InputGroup.dm = 1;
    InputGroup.dn = 2;
    InputGroup.my = /*@__PURE__*/ new CornerRadius(1, 4, 4, 4, 4);
    InputGroup.te = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    InputGroup.pq = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.pr = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.ps = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.dw = 1;
    InputGroup.dv = 2;
    InputGroup.ds = 2;
    InputGroup.pv = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.pw = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.pu = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.pt = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.dt = 0;
    InputGroup.dr = 0;
    InputGroup.dp = 0;
    InputGroup.dq = 0;
    InputGroup.du = 0;
    InputGroup.pp = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.en = 1;
    InputGroup.eo = 2;
    InputGroup.m2 = /*@__PURE__*/ new CornerRadius(1, 4, 4, 4, 4);
    InputGroup.ti = /*@__PURE__*/ new Thickness(1, 16, 0, 16, 0);
    InputGroup.qi = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.qj = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.qk = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.ew = 1;
    InputGroup.ev = 2;
    InputGroup.es = 2;
    InputGroup.qn = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.qo = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.qm = /*@__PURE__*/ BrushUtil.g(255, 186, 191, 199);
    InputGroup.ql = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    InputGroup.et = 0;
    InputGroup.er = 0;
    InputGroup.ep = 0;
    InputGroup.eq = 0;
    InputGroup.eu = 0;
    InputGroup.qh = /*@__PURE__*/ BrushUtil.g(0, 0, 0, 0);
    InputGroup.h3 = 0;
    return InputGroup;
})();
/**
 * @hidden
 */
export let InputGroupInputCollection = /*@__PURE__*/ (() => {
    class InputGroupInputCollection extends ObservableCollection$1 {
        constructor() {
            super(InputGroupItem.$, 0);
            this.collectionResetting = null;
        }
        p() {
            if (this.collectionResetting != null) {
                this.collectionResetting(this, null);
            }
            super.p();
        }
    }
    InputGroupInputCollection.$t = /*@__PURE__*/ markType(InputGroupInputCollection, 'InputGroupInputCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(InputGroupItem.$));
    return InputGroupInputCollection;
})();
/**
 * @hidden
 */
export let Label = /*@__PURE__*/ (() => {
    class Label extends InputGroupItem {
        constructor() {
            super();
            this.j = 0;
            this._view = null;
            this.z = null;
            this.y = null;
            this.n = 0;
            this.m = 1;
            this.ci = ThemeResolver.e(Label.k, Label.c1, Label.cu);
            this.cf = ThemeResolver.e(Label.k, Label.cy, Label.cr);
            this.cg = ThemeResolver.e(Label.k, Label.cz, Label.cs);
            this.ch = ThemeResolver.e(Label.k, Label.c0, Label.ct);
            this.t = null;
            this.cm = Label.c2;
            this.cj = Label.cv;
            this.ck = Label.cw;
            this.q = 0;
            this.ae = false;
            this.ac = false;
            this.u = null;
            this.cl = null;
            this.ay = "ig-label-" + Label.ar++;
            this.au = "inline-block";
            this.av = "inline-block";
            this.aw = null;
            this.as = "center";
            this.ap = 0;
            this.aa = false;
            this.ax = null;
            this.at = null;
            this.az = null;
            this.ad = false;
            this.ah = false;
            this.ab = false;
            this.ag = false;
            this.af = false;
            let a = new LabelView();
            a.b = this;
            this.view = a;
            this.view.y();
        }
        get l() {
            return this.j;
        }
        set l(a) {
            let b = this.j;
            this.j = a;
            if (b != this.j) {
                this.g("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        get i() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        }
        b1() {
            this.view.q();
            let a = false;
            if (this.z == null) {
                let b = new TransformGroup();
                b.j.add(((() => {
                    let $ret = new TranslateTransform();
                    $ret.k = this.r == 0 ? (this.view.h() * 0.5) : 0;
                    return $ret;
                })()));
                b.j.add(((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 1;
                    $ret.m = 1;
                    return $ret;
                })()));
                let c = -(this.view.h() * 1.3);
                if (this.o == 2) {
                    c = -(this.view.h() * 1.05);
                }
                if (this.o == 3) {
                    c = -(this.view.h() * 1.01);
                }
                let d = new TransformGroup();
                d.j.add(((() => {
                    let $ret = new TranslateTransform();
                    $ret.k = this.r == 2 ? c : -(this.view.h() * 0.5);
                    return $ret;
                })()));
                d.j.add(((() => {
                    let $ret = new ScaleTransform();
                    $ret.l = 0.75;
                    $ret.m = 0.75;
                    return $ret;
                })()));
                this.z = KeyFrameAnimationFactory.f.c(this.view.a(this.i).m(new AnimationKeyFrameProperty(14, b), new AnimationKeyFrameProperty(2, BrushUtil.g(0, 255, 255, 255))).m(new AnimationKeyFrameProperty(14, d), new AnimationKeyFrameProperty(2, BrushUtil.g(this.r == 2 ? 255 : 0, 255, 255, 255))));
            }
            if (this.y == null) {
                this.y = KeyFrameAnimationFactory.f.c(this.view.a(this.i).m(new AnimationKeyFrameProperty(7, this.cq)).m(new AnimationKeyFrameProperty(7, this.cn)));
            }
        }
        ca(a, b) {
            if ((b > 0 && a.playbackRate < 0) || (b < 0 && a.playbackRate > 0)) {
                a.reverse();
                a.finished.f((c) => {
                    a.commitStyles();
                    if (a == this.z && this.ag) {
                        this.z = null;
                    }
                    if (a == this.y && this.af) {
                        this.y = null;
                    }
                });
            }
            else {
                a.play();
                a.finished.f((c) => {
                    a.commitStyles();
                    if (a == this.z && this.ag) {
                        this.z = null;
                    }
                    if (a == this.y && this.af) {
                        this.y = null;
                    }
                });
            }
        }
        h(a, b, c) {
            super.h(a, b, c);
            switch (a) {
                case "BaseTheme":
                    this.cc(this.l);
                    this.ce();
                    break;
                case "TextColor":
                case "HoverTextColor":
                case "TextStyle":
                case "HighlightTextColor":
                case "HoverHighlightTextColor":
                    this.ce();
                    break;
                case "ActualTextColor":
                case "ActualHoverTextColor":
                case "ActualTextStyle":
                case "ActualHighlightTextColor":
                case "ActualHoverHighlightTextColor":
                    if (this.z != null) {
                        if (this.z.playState == 3) {
                            this.z = null;
                        }
                        else {
                            this.ag = true;
                        }
                    }
                    if (this.y != null) {
                        if (this.y.playState == 3) {
                            this.y = null;
                        }
                        else {
                            this.af = true;
                        }
                    }
                    this.cd();
                    break;
                case "Text":
                    this.view.ab();
                    break;
                case "Density":
                    this.o = this.p == 0 ? 1 : this.p;
                    break;
                case "ActualDensity":
                    this.view.ad();
                    this.view.ac();
                    break;
                case "InputGroup":
                    this.view.ac();
                    break;
                case "IsHighlighted":
                    this.b4();
                    break;
                case "IsShifted":
                    this.b5();
                    break;
                case "ShiftType":
                    if (this.z != null) {
                        if (this.z.playState == 3) {
                            this.z = null;
                        }
                        else {
                            this.ag = true;
                        }
                    }
                    this.b8();
                    break;
                case "Display":
                    this.view.v();
                    break;
                case "FlexDirection":
                    this.view.w();
                    break;
                case "FlexGrow":
                    this.view.x();
                    break;
                case "AlignItems":
                    this.view.r();
                    break;
            }
        }
        b8() {
            this.view.ac();
        }
        b5() {
            this.b1();
            let a = 1;
            let b = this.am;
            if (!b) {
                a = -1;
            }
            this.ca(this.z, a);
        }
        b4() {
            this.b1();
            let a = 1;
            let b = this.ak;
            if (!b) {
                a = -1;
            }
            this.ca(this.y, a);
        }
        ce() {
            this.cq = this.c6 != null ? this.c6 : Label.c2;
            this.cp = this.c5 != null ? this.c5 : Label.c2;
            this.cn = this.c3 != null ? this.c3 : Label.cv;
            this.v = this.x != null ? this.x : Label.w;
        }
        cd() {
            if (this.v != null) {
                this.view.af(this.v);
            }
            this.view.aa(this.cq);
        }
        cc(a) {
            Label.c2 = ThemeResolver.e(a, Label.c1, Label.cu);
            Label.cv = ThemeResolver.e(a, Label.cy, Label.cr);
            Label.cx = ThemeResolver.e(a, Label.c0, Label.ct);
            Label.cw = ThemeResolver.e(a, Label.cz, Label.cs);
        }
        get p() {
            return this.n;
        }
        set p(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.g("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get o() {
            return this.m;
        }
        set o(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.g("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get cq() {
            return this.ci;
        }
        set cq(a) {
            let b = this.ci;
            this.ci = a;
            if (b != this.ci) {
                this.g("ActualTextColor", b, a);
            }
        }
        get cn() {
            return this.cf;
        }
        set cn(a) {
            let b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.g("ActualHighlightTextColor", b, a);
            }
        }
        get co() {
            return this.cg;
        }
        set co(a) {
            let b = this.cg;
            this.cg = a;
            if (b != this.cg) {
                this.g("ActualHoverHighlightTextColor", b, a);
            }
        }
        get cp() {
            return this.ch;
        }
        set cp(a) {
            let b = this.ch;
            this.ch = a;
            if (b != this.ch) {
                this.g("ActualHoverTextColor", b, a);
            }
        }
        get v() {
            return this.t;
        }
        set v(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.g("ActualTextStyle", b, a);
            }
        }
        get c6() {
            return this.cm;
        }
        set c6(a) {
            let b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.g("TextColor", b, a);
            }
        }
        get c3() {
            return this.cj;
        }
        set c3(a) {
            let b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.g("HighlightTextColor", b, a);
            }
        }
        get c4() {
            return this.ck;
        }
        set c4(a) {
            let b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.g("HoverHighlightTextColor", b, a);
            }
        }
        get r() {
            return this.q;
        }
        set r(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.g("ShiftType", enumGetBox(LabelShiftType_$type, b), enumGetBox(LabelShiftType_$type, a));
            }
        }
        get am() {
            return this.ae;
        }
        set am(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.g("IsShifted", b, a);
            }
        }
        get ak() {
            return this.ac;
        }
        set ak(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.g("IsHighlighted", b, a);
            }
        }
        b6() {
            this.al = true;
        }
        b7() {
            this.al = false;
        }
        get x() {
            return this.u;
        }
        set x(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.g("TextStyle", b, a);
            }
        }
        get c5() {
            return this.cl;
        }
        set c5(a) {
            let b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.g("HoverTextColor", b, a);
            }
        }
        get bn() {
            return this.ay;
        }
        set bn(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.g("Id", b, a);
            }
        }
        get bc() {
            return this.au;
        }
        set bc(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.g("Display", b, a);
            }
        }
        get be() {
            return this.av;
        }
        set be(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.g("FlexDirection", b, a);
            }
        }
        get bg() {
            return this.aw;
        }
        set bg(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.g("FlexGrow", b, a);
            }
        }
        get a6() {
            return this.as;
        }
        set a6(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.g("AlignItems", b, a);
            }
        }
        get ai() {
            return this.aa;
        }
        get aq() {
            return this.ap;
        }
        set aq(a) {
            let b = this.ap;
            this.ap = a;
            this.aa = true;
            if (b != this.ap) {
                this.g("TabIndex", b, a);
            }
        }
        get bi() {
            return this.ax;
        }
        set bi(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.g("TabIndex", b, a);
            }
        }
        get a8() {
            return this.at;
        }
        set a8(a) {
            let b = this.at;
            this.at = a;
            if (b != this.at) {
                this.g("AriaLabel", b, a);
            }
        }
        get text() {
            return this.az;
        }
        set text(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.g("Text", b, a);
            }
        }
        get al() {
            return this.ad;
        }
        set al(a) {
            let b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.g("IsHover", b, a);
            }
        }
        get ao() {
            return this.ah;
        }
        set ao(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.g("Value", b, a);
            }
        }
        get disabled() {
            return this.ab;
        }
        set disabled(a) {
            let b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.g("IsDisabled", b, a);
            }
        }
        b9() {
            this.view.ab();
        }
        onDetachedFromUI() {
            this.view.u();
        }
        onAttachedToUI() {
            this.view.s();
        }
        an() {
            return this.view.e();
        }
        provideContainer(a) {
            this.view.t(a);
        }
    }
    Label.$t = /*@__PURE__*/ markType(Label, 'Label', InputGroupItem.$);
    Label.c1 = /*@__PURE__*/ BrushUtil.g(221, 0, 0, 0);
    Label.cy = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    Label.c0 = /*@__PURE__*/ BrushUtil.g(221, 0, 0, 0);
    Label.cz = /*@__PURE__*/ BrushUtil.g(255, 0, 153, 155);
    Label.cu = /*@__PURE__*/ BrushUtil.g(255, 24, 29, 31);
    Label.cr = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    Label.ct = /*@__PURE__*/ BrushUtil.g(255, 24, 29, 31);
    Label.cs = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    Label.k = 2;
    Label.c2 = /*@__PURE__*/ ThemeResolver.e(Label.k, Label.c1, Label.cu);
    Label.cv = /*@__PURE__*/ ThemeResolver.e(Label.k, Label.cy, Label.cr);
    Label.cx = /*@__PURE__*/ ThemeResolver.e(Label.k, Label.c0, Label.ct);
    Label.cw = /*@__PURE__*/ ThemeResolver.e(Label.k, Label.cz, Label.cs);
    Label.w = null;
    Label.ar = 0;
    return Label;
})();
/**
 * @hidden
 */
export let Input = /*@__PURE__*/ (() => {
    class Input extends InputGroupItem {
        constructor() {
            super();
            this.v = null;
            this.av = 0;
            this.aw = 0;
            this.r = 0;
            this.bb = "";
            this.a5 = "";
            this.ab = false;
            this.a6 = null;
            this.ac = false;
            this.ai = false;
            this._view = null;
            this.o = 0;
            this.j = 1;
            this.i = 1;
            this.ba = null;
            this.bd = "_";
            this.ae = false;
            this.c7 = Input.dd;
            this.c6 = Input.dc;
            this.w = null;
            this.c9 = Input.dd;
            this.keyDown = null;
            this.keyUp = null;
            this.keyPress = null;
            this.gotFocus = null;
            this.lostFocus = null;
            this.mouseDown = null;
            this.mouseUp = null;
            this.x = null;
            this.a9 = "text";
            this.bc = "text";
            this.c8 = null;
            this.a8 = "ig-input-" + Input.a3++;
            this.ax = 0;
            this.ad = false;
            this.a7 = null;
            this.a4 = null;
            this.ah = false;
            this.be = null;
            this.ag = false;
            this.af = false;
            this.change = null;
            this.changing = null;
            this.compositionStart = null;
            this.compositionEnd = null;
            this.v = new MaskParsingService();
            let a = new InputView();
            a.a = this;
            this.view = a;
            this.view.al();
            Input.z = new FontInfo();
            Input.z.n = "'Segoe UI', Verdana";
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        get p() {
            return this.o;
        }
        set p(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.g("ShiftType", enumGetBox(InputShiftType_$type, b), enumGetBox(InputShiftType_$type, a));
            }
        }
        get l() {
            return this.j;
        }
        set l(a) {
            let b = this.j;
            this.j = a;
            if (b != this.j) {
                this.g("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get k() {
            return this.i;
        }
        set k(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.g("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get bw() {
            return this.ba;
        }
        set bw(a) {
            let b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.g("Mask", b, a);
            }
        }
        get b0() {
            return this.bd;
        }
        set b0(a) {
            let b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.g("PromptChar", b, a);
            }
        }
        get al() {
            return this.ae;
        }
        set al(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.g("IncludeLiterals", b, a);
            }
        }
        h(a, b, c) {
            super.h(a, b, c);
            switch (a) {
                case "TextColor":
                case "HoverTextColor":
                case "TextStyle":
                    this.c4();
                    break;
                case "ActualTextColor":
                case "ActualHoverTextColor":
                case "ActualTextStyle":
                    this.c3();
                    break;
                case "Value":
                    if (!this.af) {
                        this.view.aq(this.b6);
                        if (this.b != null) {
                            this.b.mj();
                        }
                        if (this.bw != null && !this.ai) {
                            this.c5(this.b6);
                        }
                    }
                    break;
                case "Density":
                    this.k = this.l == 0 ? 1 : this.l;
                    break;
                case "ActualDensity":
                    this.view.av();
                    this.view.au();
                    break;
                case "InputGroup":
                    this.cl();
                    break;
                case "ShiftType":
                    this.cv();
                    break;
                case "InputType":
                    this.cw();
                    break;
                case "Placeholder":
                    this.cu();
                    break;
                case "Mask":
                    this.by = this.bw;
                    break;
                case "PromptChar": break;
                case "IncludeLiterals": break;
            }
        }
        cu() {
            this.view.an();
        }
        cw() {
            this.view.ap();
        }
        cv() {
            this.view.au();
        }
        cl() {
            this.view.au();
        }
        c4() {
            this.db = this.df != null ? this.df : Input.dd;
            this.da = this.de != null ? this.de : Input.dd;
            this.y = this.aa != null ? this.aa : Input.z;
        }
        c3() {
            if (this.y != null) {
                this.view.ax(this.y);
            }
            NativeUI.n(this.view.n, this.db);
        }
        get db() {
            return this.c7;
        }
        set db(a) {
            let b = this.c7;
            this.c7 = a;
            if (b != this.c7) {
                this.g("ActualTextColor", b, a);
            }
        }
        get da() {
            return this.c6;
        }
        set da(a) {
            let b = this.c6;
            this.c6 = a;
            if (b != this.c6) {
                this.g("ActualHoverTextColor", b, a);
            }
        }
        get y() {
            return this.w;
        }
        set y(a) {
            let b = this.w;
            this.w = a;
            if (b != this.w) {
                this.g("ActualTextStyle", b, a);
            }
        }
        get df() {
            return this.c9;
        }
        set df(a) {
            let b = this.c9;
            this.c9 = a;
            if (b != this.c9) {
                this.g("TextColor", b, a);
            }
        }
        cc() {
            if (this.bw != null) {
                this.c1(this.b6);
            }
            if (null != this.lostFocus) {
                this.lostFocus(this, EventArgs.empty);
            }
        }
        ck() {
            if (this.bw != null) {
                this.c2(this.b6);
            }
            if (null != this.gotFocus) {
                this.gotFocus(this, EventArgs.empty);
            }
        }
        cm(a) {
            if (this.bw != null) {
                let b = a.keyCode;
                if ((b == 17 && b == 90) || (b == 17 && b == 89)) {
                    a.preventDefault();
                }
                this.r = b;
                this.aw = this.az();
                this.av = this.ay();
            }
            if (null != this.keyDown) {
                this.keyDown(this, a);
            }
        }
        co(a) {
            if (null != this.keyUp) {
                this.keyUp(this, a);
            }
        }
        cn(a) {
            if (null != this.keyPress) {
                this.keyPress(this, a);
            }
        }
        cp(a) {
            if (null != this.mouseDown) {
                this.mouseDown(this, a);
            }
        }
        cs(a) {
            if (null != this.mouseUp) {
                this.mouseUp(this, a);
            }
        }
        ct() {
            if (this.bw != null) {
                this.bb = this.b6;
                this.aw = this.az();
            }
        }
        ci() {
            if (this.bw != null) {
                if (!this.ab) {
                    this.c2(this.a5);
                }
            }
        }
        cj() {
            if (this.bw != null) {
                if (!this.ab) {
                    this.c1(this.b6);
                }
            }
        }
        cd() {
            this.af = true;
            this.b6 = this.view.p();
            if (this.change != null) {
                this.change(this, ((() => {
                    let $ret = new InputChangeEventArgs();
                    $ret.value = this.b6;
                    $ret.isCompositionInProgress = this.view.d;
                    return $ret;
                })()));
            }
            this.af = false;
        }
        ce() {
            this.af = true;
            this.b6 = this.view.p();
            this.af = false;
            if (this.bw != null) {
                this.ai = true;
                if (this.ac) {
                    this.aw = this.az();
                }
                if (this.b6.length < this.bb.length && this.r == 229) {
                    this.r = 8;
                }
                let a = this.az();
                let b = this.ay();
                let c = "";
                switch (this.r) {
                    case 46:
                        this.av = this.aw == this.av ? ++this.av : this.av;
                        break;
                    case 8:
                        this.aw = this.az();
                        break;
                    default:
                        c = this.b6.substr(this.aw, this.ay() - this.aw);
                        break;
                }
                let d = new MaskOptions();
                d.a = this.bw;
                d.b = this.b0;
                let e = this.v.a(this.bb, c, d, this.aw, this.av);
                this.b6 = e.b;
                if (this.r == 8) {
                    e.a = this.aw;
                }
                this.c0(e.a, e.a);
                let f = this.v.h(this.b6, d);
                this.a5 = this.al ? this.b6 : f;
                this.b8();
                this.ai = false;
            }
            this.af = true;
            if (this.changing != null) {
                this.changing(this, ((() => {
                    let $ret = new InputChangeEventArgs();
                    $ret.value = this.b6;
                    $ret.isCompositionInProgress = this.view.d;
                    return $ret;
                })()));
            }
            this.af = false;
        }
        cg() {
            if (this.compositionStart != null) {
                this.compositionStart(this, new EventArgs());
            }
        }
        cf() {
            if (this.compositionEnd != null) {
                this.compositionEnd(this, new EventArgs());
            }
        }
        cq() {
            this.an = true;
        }
        cr() {
            this.an = false;
        }
        get aa() {
            return this.x;
        }
        set aa(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.g("TextStyle", b, a);
            }
        }
        get bs() {
            return this.a9;
        }
        set bs(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.g("InputType", b, a);
            }
        }
        get by() {
            return this.bc;
        }
        set by(a) {
            let b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.g("Placeholder", b, a);
            }
        }
        get de() {
            return this.c8;
        }
        set de(a) {
            let b = this.c8;
            this.c8 = a;
            if (b != this.c8) {
                this.g("HoverTextColor", b, a);
            }
        }
        get bp() {
            return this.a8;
        }
        set bp(a) {
            let b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.g("Id", b, a);
            }
        }
        get aj() {
            return this.ad;
        }
        get a2() {
            return this.ax;
        }
        set a2(a) {
            let b = this.ax;
            this.ax = a;
            this.ad = true;
            if (b != this.ax) {
                this.g("TabIndex", b, a);
            }
        }
        get bm() {
            return this.a7;
        }
        set bm(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.g("TabIndex", b, a);
            }
        }
        get bj() {
            return this.a4;
        }
        set bj(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.g("AriaLabel", b, a);
            }
        }
        get an() {
            return this.ah;
        }
        set an(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.g("IsHover", b, a);
            }
        }
        get b6() {
            return this.be;
        }
        set b6(a) {
            let b = this.be;
            this.be = a;
            if (b != this.be) {
                this.g("Value", b, a);
            }
        }
        get ak() {
            return !stringIsNullOrEmpty(this.b6);
        }
        get disabled() {
            return this.ag;
        }
        set disabled(a) {
            let b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.g("IsDisabled", b, a);
            }
        }
        cx() {
        }
        onDetachedFromUI() {
            this.view.aj();
        }
        onAttachedToUI() {
            this.view.ah();
        }
        ao() {
            return this.view.e();
        }
        provideContainer(a) {
            this.view.ai(a);
        }
        ca() {
            this.ck();
            this.view.ak();
        }
        cz() {
            this.view.ao();
        }
        c0(a, b) {
            this.view.as(a, b);
        }
        c2(a) {
            this.ai = true;
            let b = new MaskOptions();
            b.a = this.bw;
            b.b = this.b0;
            this.b6 = this.v.g(this.b6, b);
            this.bb = this.b6;
            this.ai = false;
        }
        c1(a) {
            this.ai = true;
            let b = new MaskOptions();
            b.a = this.bw;
            b.b = this.b0;
            if (a == this.v.g(null, b)) {
                this.b6 = "";
            }
            this.ai = false;
        }
        c5(a) {
            let b = new MaskOptions();
            b.a = this.bw;
            b.b = this.b0;
            if (this.b0 != null && this.b0.length > 1) {
                b.b = this.b0.substr(0, 1);
            }
            this.b6 = a != null ? this.v.g(a, b) : "";
            this.a5 = this.al ? this.b6 : a;
            if (this.changing != null) {
                this.changing(this, ((() => {
                    let $ret = new InputChangeEventArgs();
                    $ret.value = this.b6;
                    $ret.isCompositionInProgress = this.view.d;
                    return $ret;
                })()));
            }
        }
        b8() {
            this.bb = this.b6;
            this.ac = false;
            this.aw = 0;
            this.av = 0;
            this.r = 0;
        }
        az() {
            let a = this.view.m();
            let b = this.view.l();
            return a == b && this.ac ? b - this.a6.length : a;
        }
        ay() {
            return this.view.l();
        }
        get selectionStart() {
            return this.az();
        }
        set selectionStart(a) {
            this.view.at(a);
        }
        get selectionEnd() {
            return this.ay();
        }
        set selectionEnd(a) {
            this.view.ar(a);
        }
    }
    Input.$t = /*@__PURE__*/ markType(Input, 'Input', InputGroupItem.$);
    Input.dd = /*@__PURE__*/ BrushUtil.g(221, 0, 0, 0);
    Input.dc = /*@__PURE__*/ BrushUtil.g(221, 0, 0, 0);
    Input.z = null;
    Input.a3 = 0;
    return Input;
})();
//# sourceMappingURL=InputGroupView_combined.js.map
